/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

#ifdef IPV6
#define RIP_DEFAULT_TTL_SECURITY 2
#else
#define RIP_DEFAULT_TTL_SECURITY 0
#endif

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


/* Line 371 of yacc.c  */
#line 599 "cf-parse.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     DEFINE = 277,
     ON = 278,
     OFF = 279,
     YES = 280,
     NO = 281,
     S = 282,
     MS = 283,
     US = 284,
     LOG = 285,
     SYSLOG = 286,
     ALL = 287,
     DEBUG = 288,
     TRACE = 289,
     INFO = 290,
     REMOTE = 291,
     WARNING = 292,
     ERROR = 293,
     AUTH = 294,
     FATAL = 295,
     BUG = 296,
     STDERR = 297,
     SOFT = 298,
     TIMEFORMAT = 299,
     ISO = 300,
     OLD = 301,
     SHORT = 302,
     LONG = 303,
     BASE = 304,
     NAME = 305,
     CONFIRM = 306,
     UNDO = 307,
     CHECK = 308,
     TIMEOUT = 309,
     CONFIGURE = 310,
     DOWN = 311,
     KERNEL = 312,
     PERSIST = 313,
     SCAN = 314,
     TIME = 315,
     LEARN = 316,
     DEVICE = 317,
     ROUTES = 318,
     GRACEFUL = 319,
     RESTART = 320,
     KRT_SOURCE = 321,
     KRT_METRIC = 322,
     TABLE = 323,
     KRT_PREFSRC = 324,
     KRT_REALM = 325,
     ROUTER = 326,
     ID = 327,
     PROTOCOL = 328,
     TEMPLATE = 329,
     PREFERENCE = 330,
     DISABLED = 331,
     DIRECT = 332,
     INTERFACE = 333,
     IMPORT = 334,
     EXPORT = 335,
     FILTER = 336,
     NONE = 337,
     STATES = 338,
     FILTERS = 339,
     RECEIVE = 340,
     LIMIT = 341,
     ACTION = 342,
     WARN = 343,
     BLOCK = 344,
     DISABLE = 345,
     KEEP = 346,
     FILTERED = 347,
     PASSWORD = 348,
     FROM = 349,
     PASSIVE = 350,
     TO = 351,
     EVENTS = 352,
     PACKETS = 353,
     PROTOCOLS = 354,
     INTERFACES = 355,
     PRIMARY = 356,
     STATS = 357,
     COUNT = 358,
     FOR = 359,
     COMMANDS = 360,
     PREEXPORT = 361,
     GENERATE = 362,
     ROA = 363,
     MAX = 364,
     FLUSH = 365,
     AS = 366,
     LISTEN = 367,
     BGP = 368,
     V6ONLY = 369,
     DUAL = 370,
     ADDRESS = 371,
     PORT = 372,
     PASSWORDS = 373,
     DESCRIPTION = 374,
     SORTED = 375,
     RELOAD = 376,
     IN = 377,
     OUT = 378,
     MRTDUMP = 379,
     MESSAGES = 380,
     RESTRICT = 381,
     MEMORY = 382,
     IGP_METRIC = 383,
     CLASS = 384,
     DSCP = 385,
     WAIT = 386,
     SHOW = 387,
     STATUS = 388,
     SUMMARY = 389,
     ROUTE = 390,
     SYMBOLS = 391,
     ADD = 392,
     DELETE = 393,
     DUMP = 394,
     RESOURCES = 395,
     SOCKETS = 396,
     NEIGHBORS = 397,
     ATTRIBUTES = 398,
     EVAL = 399,
     ECHO = 400,
     ENABLE = 401,
     FUNCTION = 402,
     PRINT = 403,
     PRINTN = 404,
     UNSET = 405,
     RETURN = 406,
     ACCEPT = 407,
     REJECT = 408,
     QUITBIRD = 409,
     INT = 410,
     BOOL = 411,
     IP = 412,
     PREFIX = 413,
     PAIR = 414,
     QUAD = 415,
     EC = 416,
     SET = 417,
     STRING = 418,
     BGPMASK = 419,
     BGPPATH = 420,
     CLIST = 421,
     ECLIST = 422,
     IF = 423,
     THEN = 424,
     ELSE = 425,
     CASE = 426,
     TRUE = 427,
     FALSE = 428,
     RT = 429,
     RO = 430,
     UNKNOWN = 431,
     GENERIC = 432,
     GW = 433,
     NET = 434,
     MASK = 435,
     PROTO = 436,
     SOURCE = 437,
     SCOPE = 438,
     CAST = 439,
     DEST = 440,
     IFNAME = 441,
     IFINDEX = 442,
     LEN = 443,
     DEFINED = 444,
     CONTAINS = 445,
     RESET = 446,
     PREPEND = 447,
     FIRST = 448,
     LAST = 449,
     MATCH = 450,
     ROA_CHECK = 451,
     EMPTY = 452,
     WHERE = 453,
     BFD = 454,
     MIN = 455,
     IDLE = 456,
     RX = 457,
     TX = 458,
     INTERVAL = 459,
     MULTIPLIER = 460,
     MULTIHOP = 461,
     NEIGHBOR = 462,
     DEV = 463,
     LOCAL = 464,
     SESSIONS = 465,
     HOLD = 466,
     CONNECT = 467,
     RETRY = 468,
     KEEPALIVE = 469,
     STARTUP = 470,
     VIA = 471,
     NEXT = 472,
     HOP = 473,
     SELF = 474,
     DEFAULT = 475,
     PATH = 476,
     METRIC = 477,
     START = 478,
     DELAY = 479,
     FORGET = 480,
     AFTER = 481,
     BGP_PATH = 482,
     BGP_LOCAL_PREF = 483,
     BGP_MED = 484,
     BGP_ORIGIN = 485,
     BGP_NEXT_HOP = 486,
     BGP_ATOMIC_AGGR = 487,
     BGP_AGGREGATOR = 488,
     BGP_COMMUNITY = 489,
     BGP_EXT_COMMUNITY = 490,
     RR = 491,
     RS = 492,
     CLIENT = 493,
     CLUSTER = 494,
     AS4 = 495,
     ADVERTISE = 496,
     IPV4 = 497,
     CAPABILITIES = 498,
     PREFER = 499,
     OLDER = 500,
     MISSING = 501,
     LLADDR = 502,
     DROP = 503,
     IGNORE = 504,
     REFRESH = 505,
     INTERPRET = 506,
     COMMUNITIES = 507,
     BGP_ORIGINATOR_ID = 508,
     BGP_CLUSTER_LIST = 509,
     IGP = 510,
     GATEWAY = 511,
     RECURSIVE = 512,
     MED = 513,
     TTL = 514,
     SECURITY = 515,
     DETERMINISTIC = 516,
     SECONDARY = 517,
     ALLOW = 518,
     PATHS = 519,
     AWARE = 520,
     OSPF = 521,
     AREA = 522,
     OSPF_METRIC1 = 523,
     OSPF_METRIC2 = 524,
     OSPF_TAG = 525,
     OSPF_ROUTER_ID = 526,
     RFC1583COMPAT = 527,
     STUB = 528,
     TICK = 529,
     COST = 530,
     COST2 = 531,
     RETRANSMIT = 532,
     HELLO = 533,
     TRANSMIT = 534,
     PRIORITY = 535,
     DEAD = 536,
     TYPE = 537,
     BROADCAST = 538,
     BCAST = 539,
     NONBROADCAST = 540,
     NBMA = 541,
     POINTOPOINT = 542,
     PTP = 543,
     POINTOMULTIPOINT = 544,
     PTMP = 545,
     SIMPLE = 546,
     AUTHENTICATION = 547,
     STRICT = 548,
     CRYPTOGRAPHIC = 549,
     ELIGIBLE = 550,
     POLL = 551,
     NETWORKS = 552,
     HIDDEN = 553,
     VIRTUAL = 554,
     LINK = 555,
     ONLY = 556,
     BUFFER = 557,
     LARGE = 558,
     NORMAL = 559,
     STUBNET = 560,
     TAG = 561,
     EXTERNAL = 562,
     LSADB = 563,
     ECMP = 564,
     WEIGHT = 565,
     NSSA = 566,
     TRANSLATOR = 567,
     STABILITY = 568,
     GLOBAL = 569,
     LSID = 570,
     INSTANCE = 571,
     REAL = 572,
     NETMASK = 573,
     LENGTH = 574,
     TOPOLOGY = 575,
     STATE = 576,
     PIPE = 577,
     PEER = 578,
     MODE = 579,
     OPAQUE = 580,
     TRANSPARENT = 581,
     RADV = 582,
     RA = 583,
     MANAGED = 584,
     OTHER = 585,
     CONFIG = 586,
     MTU = 587,
     REACHABLE = 588,
     RETRANS = 589,
     TIMER = 590,
     CURRENT = 591,
     VALID = 592,
     PREFERRED = 593,
     MULT = 594,
     LIFETIME = 595,
     SKIP = 596,
     ONLINK = 597,
     AUTONOMOUS = 598,
     RDNSS = 599,
     DNSSL = 600,
     NS = 601,
     DOMAIN = 602,
     TRIGGER = 603,
     SENSITIVE = 604,
     RIP = 605,
     INFINITY = 606,
     PERIOD = 607,
     GARBAGE = 608,
     MULTICAST = 609,
     QUIET = 610,
     NOLISTEN = 611,
     VERSION1 = 612,
     PLAINTEXT = 613,
     MD5 = 614,
     HONOR = 615,
     NEVER = 616,
     ALWAYS = 617,
     RIP_METRIC = 618,
     RIP_TAG = 619,
     STATIC = 620,
     PROHIBIT = 621,
     MULTIPATH = 622,
     BLACKHOLE = 623,
     UNREACHABLE = 624
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 527 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;


/* Line 387 of yacc.c  */
#line 1039 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE cf_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int cf_parse (void *YYPARSE_PARAM);
#else
int cf_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int cf_parse (void);
#else
int cf_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 1067 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  67
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2973

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  391
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  289
/* YYNRULES -- Number of rules.  */
#define YYNRULES  903
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1698

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   624

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     382,   383,    28,    26,   387,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   384,   381,
      23,    22,    24,   388,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   389,     2,   390,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   385,     2,   386,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    19,    21,    25,
      27,    30,    33,    36,    38,    40,    42,    44,    46,    47,
      49,    51,    52,    55,    58,    60,    62,    65,    68,    70,
      72,    73,    78,    81,    82,    84,    87,    89,    91,    95,
      97,   101,   103,   105,   107,   109,   111,   113,   115,   117,
     119,   124,   128,   130,   132,   134,   136,   139,   144,   148,
     152,   156,   160,   164,   169,   175,   179,   183,   188,   191,
     192,   194,   195,   197,   200,   203,   206,   210,   213,   217,
     221,   224,   228,   232,   236,   241,   247,   249,   251,   253,
     258,   259,   262,   265,   268,   270,   272,   278,   279,   281,
     285,   289,   290,   299,   301,   306,   308,   310,   311,   313,
     317,   318,   321,   324,   327,   330,   333,   336,   340,   344,
     348,   353,   356,   360,   363,   366,   368,   370,   372,   373,
     376,   379,   382,   385,   388,   390,   392,   396,   400,   401,
     403,   405,   408,   409,   411,   415,   417,   421,   423,   424,
     427,   430,   433,   436,   440,   444,   448,   449,   453,   455,
     457,   461,   463,   467,   469,   471,   473,   475,   477,   479,
     481,   483,   487,   489,   493,   495,   497,   502,   504,   505,
     509,   514,   516,   519,   520,   526,   532,   538,   544,   549,
     553,   557,   562,   568,   570,   571,   575,   580,   585,   586,
     589,   593,   597,   601,   604,   607,   610,   613,   617,   621,
     624,   627,   629,   631,   636,   637,   641,   645,   649,   650,
     652,   654,   659,   660,   663,   666,   669,   672,   675,   678,
     681,   682,   685,   695,   705,   710,   714,   718,   722,   726,
     730,   734,   738,   742,   747,   749,   751,   755,   756,   758,
     762,   766,   770,   774,   779,   784,   789,   794,   797,   799,
     801,   803,   805,   806,   808,   809,   814,   817,   819,   821,
     823,   825,   827,   829,   831,   833,   835,   837,   839,   841,
     844,   847,   848,   852,   854,   858,   860,   862,   864,   867,
     871,   874,   879,   880,   886,   887,   889,   891,   894,   896,
     900,   902,   904,   906,   908,   910,   912,   916,   918,   920,
     922,   924,   926,   930,   932,   938,   950,   952,   954,   956,
     959,   961,   969,   979,   987,   989,   991,   993,   997,   999,
    1001,  1003,  1007,  1009,  1013,  1015,  1019,  1023,  1025,  1028,
    1031,  1038,  1040,  1044,  1045,  1050,  1054,  1056,  1060,  1064,
    1068,  1071,  1074,  1077,  1080,  1081,  1084,  1087,  1088,  1090,
    1092,  1094,  1096,  1098,  1100,  1102,  1106,  1110,  1112,  1114,
    1120,  1128,  1129,  1134,  1136,  1138,  1140,  1142,  1144,  1146,
    1148,  1150,  1152,  1154,  1156,  1160,  1164,  1168,  1172,  1176,
    1180,  1184,  1188,  1192,  1196,  1200,  1204,  1208,  1212,  1215,
    1220,  1222,  1224,  1226,  1228,  1231,  1234,  1238,  1242,  1249,
    1253,  1257,  1261,  1265,  1271,  1278,  1285,  1292,  1299,  1304,
    1313,  1318,  1320,  1322,  1324,  1326,  1328,  1330,  1332,  1333,
    1335,  1339,  1341,  1345,  1346,  1348,  1353,  1360,  1365,  1369,
    1375,  1381,  1386,  1393,  1397,  1400,  1406,  1412,  1421,  1430,
    1439,  1448,  1451,  1453,  1456,  1459,  1462,  1463,  1467,  1473,
    1474,  1477,  1482,  1487,  1492,  1495,  1498,  1499,  1503,  1504,
    1508,  1512,  1515,  1516,  1519,  1522,  1523,  1526,  1527,  1530,
    1535,  1541,  1544,  1548,  1552,  1558,  1565,  1573,  1580,  1585,
    1590,  1596,  1603,  1610,  1616,  1620,  1624,  1629,  1635,  1641,
    1647,  1653,  1659,  1664,  1669,  1675,  1681,  1687,  1693,  1699,
    1705,  1711,  1717,  1724,  1731,  1740,  1747,  1754,  1760,  1765,
    1771,  1776,  1782,  1787,  1793,  1798,  1804,  1810,  1816,  1822,
    1829,  1835,  1841,  1848,  1854,  1860,  1865,  1868,  1872,  1876,
    1878,  1881,  1885,  1888,  1893,  1896,  1898,  1901,  1906,  1907,
    1911,  1914,  1916,  1919,  1923,  1927,  1931,  1935,  1938,  1942,
    1943,  1949,  1950,  1956,  1959,  1962,  1964,  1969,  1971,  1973,
    1974,  1978,  1981,  1984,  1987,  1993,  1996,  1997,  2001,  2002,
    2005,  2008,  2012,  2015,  2018,  2022,  2025,  2028,  2031,  2033,
    2037,  2040,  2043,  2046,  2049,  2052,  2055,  2059,  2062,  2065,
    2068,  2071,  2074,  2077,  2080,  2083,  2087,  2091,  2095,  2098,
    2102,  2105,  2109,  2113,  2118,  2121,  2124,  2127,  2131,  2135,
    2139,  2142,  2146,  2150,  2154,  2159,  2162,  2165,  2167,  2168,
    2171,  2175,  2177,  2178,  2180,  2183,  2184,  2187,  2188,  2190,
    2194,  2195,  2196,  2199,  2200,  2204,  2205,  2209,  2210,  2214,
    2218,  2220,  2221,  2226,  2233,  2240,  2247,  2255,  2262,  2270,
    2276,  2277,  2280,  2284,  2287,  2291,  2295,  2298,  2302,  2305,
    2308,  2312,  2316,  2322,  2327,  2332,  2335,  2337,  2340,  2343,
    2344,  2348,  2349,  2353,  2356,  2357,  2361,  2367,  2368,  2373,
    2378,  2382,  2385,  2389,  2393,  2397,  2401,  2406,  2411,  2414,
    2415,  2419,  2420,  2424,  2428,  2432,  2433,  2434,  2438,  2439,
    2443,  2448,  2450,  2453,  2456,  2459,  2464,  2469,  2470,  2471,
    2475,  2476,  2480,  2484,  2486,  2487,  2488,  2491,  2494,  2495,
    2496,  2500,  2502,  2508,  2510,  2511,  2512,  2515,  2518,  2519,
    2520,  2524,  2526,  2532,  2534,  2537,  2538,  2541,  2544,  2548,
    2552,  2557,  2562,  2567,  2573,  2579,  2584,  2588,  2593,  2598,
    2603,  2608,  2610,  2612,  2614,  2616,  2618,  2620,  2622,  2624,
    2625,  2628,  2631,  2634,  2638,  2642,  2647,  2648,  2652,  2653,
    2657,  2658,  2662,  2665,  2669,  2673,  2679,  2685,  2689,  2692,
    2696,  2700,  2702,  2705,  2710,  2714,  2718,  2722,  2725,  2728,
    2731,  2734,  2737,  2742,  2744,  2746,  2748,  2750,  2752,  2754,
    2756,  2758,  2760,  2762,  2764,  2766,  2768,  2770,  2772,  2774,
    2776,  2778,  2780,  2782,  2784,  2786,  2788,  2790,  2792,  2794,
    2796,  2798,  2800,  2802,  2804,  2806,  2808,  2810,  2812,  2814,
    2816,  2818,  2820,  2822,  2824,  2826,  2828,  2830,  2832,  2834,
    2836,  2838,  2840,  2842,  2844,  2846,  2848,  2850,  2852,  2854,
    2856,  2858,  2860,  2862,  2864,  2867,  2870,  2873,  2875,  2878,
    2881,  2884,  2886,  2889,  2892,  2896,  2900,  2904,  2908,  2912,
    2916,  2920,  2922,  2924,  2926,  2928,  2930,  2932,  2934,  2936,
    2938,  2940,  2942,  2944,  2946,  2948,  2950,  2952,  2954,  2956,
    2958,  2960,  2962,  2964
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     392,     0,    -1,   393,     3,    -1,     4,   675,    -1,    -1,
     393,   674,    -1,    33,    19,    22,   556,   381,    -1,    15,
      -1,   382,   556,   383,    -1,    19,    -1,   395,    38,    -1,
     395,    39,    -1,   395,    40,    -1,   395,    -1,    34,    -1,
      36,    -1,    35,    -1,    37,    -1,    -1,    18,    -1,    19,
      -1,    -1,    30,    19,    -1,   398,   402,    -1,   400,    -1,
     398,    -1,    29,   395,    -1,   384,   398,    -1,    20,    -1,
      20,    -1,    -1,    41,   407,   408,   381,    -1,    61,    20,
      -1,    -1,    20,    -1,    42,   406,    -1,    53,    -1,    43,
      -1,   385,   409,   386,    -1,   410,    -1,   409,   387,   410,
      -1,    44,    -1,    45,    -1,    46,    -1,    47,    -1,    48,
      -1,    49,    -1,    50,    -1,    51,    -1,    52,    -1,   135,
     110,   463,   381,    -1,   135,    20,   381,    -1,   146,    -1,
      84,    -1,    60,    -1,    41,    -1,   412,    20,    -1,   412,
      20,   395,    20,    -1,   412,    56,    58,    -1,   412,    56,
      59,    -1,   412,    57,    58,    -1,   412,    57,    59,    -1,
      55,   413,   381,    -1,    66,   421,   422,     3,    -1,    66,
      54,   421,   422,     3,    -1,    66,    62,     3,    -1,    66,
      63,     3,    -1,    66,    64,   421,     3,    -1,    67,     3,
      -1,    -1,    20,    -1,    -1,    65,    -1,    65,   395,    -1,
     439,    68,    -1,    69,   397,    -1,    70,    71,   395,    -1,
      72,   397,    -1,    73,    74,   397,    -1,    75,    76,   397,
      -1,   439,    73,    -1,    70,    71,   395,    -1,   112,   404,
     401,    -1,    68,    79,   395,    -1,    82,    83,   429,   381,
      -1,    82,    83,   105,   454,   381,    -1,    15,    -1,    17,
      -1,    18,    -1,   123,   124,   431,   381,    -1,    -1,   431,
     432,    -1,   127,   398,    -1,   128,   395,    -1,   125,    -1,
     126,    -1,    75,    76,   142,   395,   381,    -1,    -1,   131,
      -1,    79,    19,   434,    -1,   119,    79,    19,    -1,    -1,
     437,   119,   400,   120,    15,   122,    15,   381,    -1,   436,
      -1,   436,   385,   437,   386,    -1,    84,    -1,    85,    -1,
      -1,    19,    -1,    19,   105,    19,    -1,    -1,    86,   395,
      -1,    87,   397,    -1,    44,   460,    -1,   135,   463,    -1,
      90,   442,    -1,    91,   442,    -1,    96,    97,   444,    -1,
      90,    97,   444,    -1,    91,    97,   444,    -1,    90,   102,
     103,   397,    -1,    79,   445,    -1,    82,    83,   429,    -1,
     130,    20,    -1,    92,   520,    -1,   521,    -1,    43,    -1,
      93,    -1,    -1,    98,    99,    -1,    98,   100,    -1,    98,
      76,    -1,    98,   101,    -1,   395,   443,    -1,    35,    -1,
      19,    -1,    44,   110,   460,    -1,    44,   116,   395,    -1,
      -1,    20,    -1,   401,    -1,    20,   401,    -1,    -1,    27,
      -1,   447,   449,   448,    -1,   450,    -1,   451,   387,   450,
      -1,   451,    -1,    -1,   453,   451,    -1,   140,   395,    -1,
     141,   395,    -1,   439,    88,    -1,   456,   440,   385,    -1,
     457,   441,   381,    -1,   457,   459,   381,    -1,    -1,    89,
     458,   451,    -1,    43,    -1,    35,    -1,   385,   461,   386,
      -1,   462,    -1,   461,   387,   462,    -1,    94,    -1,    74,
      -1,    95,    -1,   111,    -1,   108,    -1,   109,    -1,    43,
      -1,    35,    -1,   385,   464,   386,    -1,   465,    -1,   464,
     387,   465,    -1,    94,    -1,   136,    -1,   129,   385,   467,
     386,    -1,   468,    -1,    -1,   468,   381,   467,    -1,   469,
     385,   470,   386,    -1,   469,    -1,   104,    20,    -1,    -1,
     118,   105,   403,   381,   470,    -1,   118,   107,   403,   381,
     470,    -1,   163,   105,   403,   381,   470,    -1,   163,   107,
     403,   381,   470,    -1,    83,   395,   381,   470,    -1,   143,
     144,     3,    -1,   143,   138,     3,    -1,   143,   110,   511,
       3,    -1,   143,   110,    43,   511,     3,    -1,    19,    -1,
      -1,   143,   111,     3,    -1,   143,   111,   145,     3,    -1,
     143,   146,   479,     3,    -1,    -1,   479,   400,    -1,   479,
     115,   401,    -1,   479,    79,    19,    -1,   479,    92,   520,
      -1,   479,   521,    -1,   479,    43,    -1,   479,   112,    -1,
     479,   103,    -1,   479,   480,    19,    -1,   479,    84,    19,
      -1,   479,   113,    -1,   479,   114,    -1,   117,    -1,    91,
      -1,   143,   119,   482,     3,    -1,    -1,   482,   483,   400,
      -1,   482,   122,    15,    -1,   482,    79,    19,    -1,    -1,
     133,    -1,   115,    -1,   143,   147,   485,     3,    -1,    -1,
     485,    79,    -1,   485,   158,    -1,   485,    92,    -1,   485,
      84,    -1,   485,    85,    -1,   485,   119,    -1,   485,    19,
      -1,    -1,    79,    19,    -1,   148,   119,   400,   120,    15,
     122,    15,   486,     3,    -1,   149,   119,   400,   120,    15,
     122,    15,   486,     3,    -1,   121,   119,   486,     3,    -1,
     150,   151,     3,    -1,   150,   152,     3,    -1,   150,   111,
       3,    -1,   150,   153,     3,    -1,   150,   154,     3,    -1,
     150,    74,     3,    -1,   150,   110,     3,    -1,   155,   556,
       3,    -1,   156,   499,   500,     3,    -1,    43,    -1,    35,
      -1,   385,   409,   386,    -1,    -1,    15,    -1,   101,   510,
       3,    -1,   157,   510,     3,    -1,    76,   510,     3,    -1,
     132,   510,     3,    -1,   132,   133,   510,     3,    -1,   132,
     134,   510,     3,    -1,    44,   510,   460,     3,    -1,   135,
     510,   463,     3,    -1,   137,     3,    -1,    19,    -1,    43,
      -1,    20,    -1,    19,    -1,    -1,    20,    -1,    -1,    92,
      19,   513,   519,    -1,   155,   556,    -1,   166,    -1,   167,
      -1,   168,    -1,   169,    -1,   170,    -1,   171,    -1,   172,
      -1,   174,    -1,   175,    -1,   176,    -1,   177,    -1,   178,
      -1,   515,   173,    -1,   515,    19,    -1,    -1,   516,   381,
     517,    -1,   516,    -1,   516,   381,   518,    -1,   523,    -1,
      19,    -1,   519,    -1,   209,   556,    -1,   382,   518,   383,
      -1,   382,   383,    -1,   517,   385,   526,   386,    -1,    -1,
     158,    19,   525,   522,   523,    -1,    -1,   527,    -1,   562,
      -1,   527,   562,    -1,   562,    -1,   385,   526,   386,    -1,
      18,    -1,   395,    -1,    17,    -1,   529,    -1,    16,    -1,
      15,    -1,   382,   556,   383,    -1,    17,    -1,   529,    -1,
      16,    -1,   556,    -1,   532,    -1,   532,     7,   532,    -1,
      28,    -1,   382,   533,   387,   533,   383,    -1,   382,   533,
     387,   533,   383,     7,   382,   532,   387,   532,   383,    -1,
     556,    -1,   185,    -1,   186,    -1,   187,    15,    -1,   188,
      -1,   382,   536,   387,   535,   387,   535,   383,    -1,   382,
     536,   387,   535,   387,   535,     7,   535,   383,    -1,   382,
     536,   387,   535,   387,    28,   383,    -1,   534,    -1,   537,
      -1,   530,    -1,   530,     7,   530,    -1,   534,    -1,   537,
      -1,   531,    -1,   531,     7,   531,    -1,   538,    -1,   540,
     387,   538,    -1,   539,    -1,   541,   387,   539,    -1,    18,
      29,    15,    -1,   542,    -1,   542,    26,    -1,   542,    27,
      -1,   542,   385,    15,   387,    15,   386,    -1,   543,    -1,
     544,   387,   543,    -1,    -1,   545,   541,   384,   526,    -1,
     545,     6,   526,    -1,   554,    -1,   382,   556,   383,    -1,
      13,   548,    14,    -1,    29,   549,    29,    -1,    15,   548,
      -1,    28,   548,    -1,   388,   548,    -1,   546,   548,    -1,
      -1,    15,   549,    -1,   388,   549,    -1,    -1,    15,    -1,
     183,    -1,   184,    -1,    20,    -1,   529,    -1,   542,    -1,
      17,    -1,   389,   540,   390,    -1,   389,   544,   390,    -1,
      16,    -1,   547,    -1,   382,   556,   387,   556,   383,    -1,
     382,   536,   387,   556,   387,   556,   383,    -1,    -1,    19,
     382,   561,   383,    -1,    19,    -1,   105,    -1,   189,    -1,
     190,    -1,   192,    -1,   193,    -1,   194,    -1,   195,    -1,
     196,    -1,   197,    -1,   198,    -1,   382,   556,   383,    -1,
     556,    26,   556,    -1,   556,    27,   556,    -1,   556,    28,
     556,    -1,   556,    29,   556,    -1,   556,    11,   556,    -1,
     556,    12,   556,    -1,   556,    22,   556,    -1,   556,    10,
     556,    -1,   556,    23,   556,    -1,   556,     9,   556,    -1,
     556,    24,   556,    -1,   556,     8,   556,    -1,   556,    25,
     556,    -1,    31,   556,    -1,   200,   382,   556,   383,    -1,
     554,    -1,   550,    -1,   551,    -1,    86,    -1,   552,   555,
      -1,   552,   679,    -1,   556,    32,   168,    -1,   556,    32,
     199,    -1,   556,    32,   191,   382,   556,   383,    -1,   556,
      32,   204,    -1,   556,    32,   205,    -1,    26,   208,    26,
      -1,    27,   208,    27,    -1,    27,    27,   208,    27,    27,
      -1,   203,   382,   556,   387,   556,   383,    -1,   148,   382,
     556,   387,   556,   383,    -1,   149,   382,   556,   387,   556,
     383,    -1,    92,   382,   556,   387,   556,   383,    -1,   207,
     382,    19,   383,    -1,   207,   382,    19,   387,   556,   387,
     556,   383,    -1,    19,   382,   561,   383,    -1,   165,    -1,
     163,    -1,   164,    -1,    49,    -1,   159,    -1,   160,    -1,
     556,    -1,    -1,   558,    -1,   558,   387,   559,    -1,   556,
      -1,   556,   387,   560,    -1,    -1,   560,    -1,   179,   556,
     180,   528,    -1,   179,   556,   180,   528,   181,   528,    -1,
      19,    22,   556,   381,    -1,   162,   556,   381,    -1,   552,
     679,    22,   556,   381,    -1,   552,   555,    22,   556,   381,
      -1,    86,    22,   556,   381,    -1,   161,   382,   552,   679,
     383,   381,    -1,   557,   559,   381,    -1,   553,   381,    -1,
     182,   556,   385,   545,   386,    -1,   552,   679,    32,   208,
     381,    -1,   552,   679,    32,   203,   382,   556,   383,   381,
      -1,   552,   679,    32,   148,   382,   556,   383,   381,    -1,
     552,   679,    32,   149,   382,   556,   383,   381,    -1,   552,
     679,    32,    92,   382,   556,   383,   381,    -1,   439,   210,
      -1,   441,    -1,    89,   571,    -1,   217,   572,    -1,   218,
     576,    -1,    -1,   565,   564,   381,    -1,   563,   440,   385,
     565,   386,    -1,    -1,   215,   396,    -1,   211,   213,   215,
     396,    -1,   211,   214,   215,   396,    -1,   212,   214,   215,
     396,    -1,   216,   395,    -1,   106,   397,    -1,    -1,   569,
     568,   381,    -1,    -1,   385,   569,   386,    -1,   567,   452,
     570,    -1,   567,   570,    -1,    -1,    30,    19,    -1,   219,
      20,    -1,    -1,   220,   398,    -1,    -1,   217,   397,    -1,
     398,   573,   574,   575,    -1,   143,   210,   221,   475,     3,
      -1,   439,   124,    -1,   578,   440,   385,    -1,   579,   441,
     381,    -1,   579,   220,   122,   395,   381,    -1,   579,   220,
     398,   122,   395,   381,    -1,   579,   218,   398,   399,   122,
     395,   381,    -1,   579,   247,   250,    83,   429,   381,    -1,
     579,   247,   249,   381,    -1,   579,   248,   249,   381,    -1,
     579,   222,    71,   395,   381,    -1,   579,   226,   222,    71,
     395,   381,    -1,   579,   223,   224,    71,   395,   381,    -1,
     579,   225,    71,   395,   381,    -1,   579,    88,   381,    -1,
     579,   217,   381,    -1,   579,   217,   395,   381,    -1,   579,
     228,   229,   230,   381,    -1,   579,   228,   229,   102,   381,
      -1,   579,   257,   258,   230,   381,    -1,   579,   257,   258,
     259,   381,    -1,   579,   257,   258,   260,   381,    -1,   579,
     267,    88,   381,    -1,   579,   267,   268,   381,    -1,   579,
     232,   233,   397,   381,    -1,   579,   269,   233,   397,   381,
      -1,   579,   266,   233,   397,   381,    -1,   579,   255,   256,
     397,   381,    -1,   579,   272,   269,   397,   381,    -1,   579,
     231,   240,   395,   381,    -1,   579,   231,   239,   395,   381,
      -1,   579,   193,   127,   398,   381,    -1,   579,   234,   235,
      71,   395,   381,    -1,   579,    49,   236,    71,   395,   381,
      -1,   579,    49,   142,    71,   395,   387,   395,   381,    -1,
     579,   101,   237,    49,   397,   381,    -1,   579,   157,   146,
     261,   397,   381,    -1,   579,   157,   251,   397,   381,    -1,
     579,   254,   397,   381,    -1,   579,   252,   253,   397,   381,
      -1,   579,   104,    20,   381,    -1,   579,   146,    97,   395,
     381,    -1,   579,   106,   397,   381,    -1,   579,   262,   263,
     397,   381,    -1,   579,   273,   397,   381,    -1,   579,   148,
     275,   213,   381,    -1,   579,   148,   275,   214,   381,    -1,
     579,   148,   275,   397,   381,    -1,   579,   274,   220,   122,
     381,    -1,   579,   274,   220,   122,   395,   381,    -1,   579,
      75,    76,   397,   381,    -1,   579,    75,    76,   276,   381,
      -1,   579,    75,    76,    71,   395,   381,    -1,   579,   266,
      79,   445,   381,    -1,   579,   270,   271,   397,   381,    -1,
     579,   210,   397,   381,    -1,   439,   277,    -1,   580,   440,
     385,    -1,   581,   582,   381,    -1,   441,    -1,   283,   397,
      -1,   284,    82,   397,    -1,   320,   397,    -1,   320,   397,
      97,   395,    -1,   285,   395,    -1,   584,    -1,   278,   429,
      -1,   583,   385,   585,   386,    -1,    -1,   585,   586,   381,
      -1,   284,   397,    -1,   322,    -1,   145,   397,    -1,   231,
     322,   397,    -1,   231,   286,   395,    -1,   231,   287,   395,
      -1,   284,   286,   395,    -1,   323,   397,    -1,   323,   324,
     395,    -1,    -1,   308,   587,   385,   598,   386,    -1,    -1,
     318,   588,   385,   598,   386,    -1,   316,   589,    -1,    89,
     611,    -1,   593,    -1,   590,   385,   591,   386,    -1,   590,
      -1,   400,    -1,    -1,   591,   592,   381,    -1,   309,   397,
      -1,   145,   397,    -1,   286,   395,    -1,   596,   606,   385,
     594,   386,    -1,   596,   606,    -1,    -1,   594,   595,   381,
      -1,    -1,   289,   395,    -1,   288,   395,    -1,   290,   235,
     395,    -1,   142,   395,    -1,   292,   395,    -1,   292,   114,
     395,    -1,   303,    93,    -1,   303,   302,    -1,   303,   305,
      -1,   466,    -1,   310,   311,   429,    -1,   286,   395,    -1,
     289,   395,    -1,   307,   395,    -1,   288,   395,    -1,   142,
     395,    -1,   292,   395,    -1,   292,   114,   395,    -1,   293,
     294,    -1,   293,   295,    -1,   293,   296,    -1,   293,   297,
      -1,   293,   298,    -1,   293,   299,    -1,   293,   300,    -1,
     293,   301,    -1,   328,   294,   397,    -1,   299,   329,   397,
      -1,   290,   235,   395,    -1,   291,   395,    -1,   304,   296,
     397,    -1,   284,   397,    -1,    64,   311,   397,    -1,   320,
     321,   395,    -1,   153,   385,   602,   386,    -1,   303,    93,
      -1,   303,   302,    -1,   303,   305,    -1,   213,   313,   315,
      -1,   213,   313,   314,    -1,   213,   313,   395,    -1,   214,
     455,    -1,   214,   291,   395,    -1,   214,   330,   395,    -1,
     270,   271,   397,    -1,   270,   271,   214,   312,    -1,   210,
     397,    -1,   273,   397,    -1,   466,    -1,    -1,   598,   599,
      -1,   600,   601,   381,    -1,   400,    -1,    -1,   309,    -1,
     317,   395,    -1,    -1,   602,   604,    -1,    -1,   306,    -1,
      18,   603,   381,    -1,    -1,    -1,   327,   395,    -1,    -1,
     451,   608,   606,    -1,    -1,   609,   597,   381,    -1,    -1,
     385,   609,   386,    -1,   605,   607,   610,    -1,    20,    -1,
      -1,   143,   277,   475,     3,    -1,   143,   277,   153,   475,
     612,     3,    -1,   143,   277,    89,   475,   612,     3,    -1,
     143,   277,   331,   475,   612,     3,    -1,   143,   277,   331,
      43,   475,   612,     3,    -1,   143,   277,   332,   475,   612,
       3,    -1,   143,   277,   332,    43,   475,   612,     3,    -1,
     143,   277,   319,   621,     3,    -1,    -1,   621,   325,    -1,
     621,   278,   429,    -1,   621,   311,    -1,   621,   293,    15,
      -1,   621,   326,   429,    -1,   621,   230,    -1,   621,    82,
     429,    -1,   621,    19,    -1,   439,   333,    -1,   622,   440,
     385,    -1,   623,   441,   381,    -1,   623,   334,    79,    19,
     381,    -1,   623,   335,   336,   381,    -1,   623,   335,   337,
     381,    -1,   439,   338,    -1,   441,    -1,    89,   637,    -1,
     169,   643,    -1,    -1,   355,   626,   649,    -1,    -1,   356,
     627,   655,    -1,   359,   400,    -1,    -1,   628,   625,   381,
      -1,   624,   440,   385,   628,   386,    -1,    -1,   211,   339,
     215,   395,    -1,   120,   339,   215,   395,    -1,   211,   235,
     395,    -1,   340,   397,    -1,   341,   342,   397,    -1,   311,
     343,   395,    -1,   344,    71,   395,    -1,   345,   346,   395,
      -1,   347,   229,    97,   395,    -1,   231,   351,   395,   657,
      -1,   169,   643,    -1,    -1,   355,   632,   649,    -1,    -1,
     356,   633,   655,    -1,   355,   220,   397,    -1,   356,   220,
     397,    -1,    -1,    -1,   635,   631,   381,    -1,    -1,   385,
     635,   386,    -1,   630,   452,   636,   634,    -1,   400,    -1,
     352,   397,    -1,   353,   397,    -1,   354,   397,    -1,   348,
     351,   395,   657,    -1,   349,   351,   395,   657,    -1,    -1,
      -1,   641,   639,   381,    -1,    -1,   385,   641,   386,    -1,
     638,   642,   640,    -1,   398,    -1,    -1,    -1,   357,   644,
      -1,   351,   656,    -1,    -1,    -1,   648,   646,   381,    -1,
     644,    -1,   385,   645,   648,   386,   647,    -1,    20,    -1,
      -1,    -1,   358,   650,    -1,   351,   656,    -1,    -1,    -1,
     654,   652,   381,    -1,   650,    -1,   385,   651,   654,   386,
     653,    -1,   395,    -1,   350,   395,    -1,    -1,   360,   397,
      -1,   439,   361,    -1,   658,   440,   385,    -1,   659,   441,
     381,    -1,   659,   362,   395,   381,    -1,   659,   128,   395,
     381,    -1,   659,   363,   395,   381,    -1,   659,   364,    71,
     395,   381,    -1,   659,    65,    71,   395,   381,    -1,   659,
     303,   660,   381,    -1,   659,   466,   381,    -1,   659,   371,
     373,   381,    -1,   659,   371,   218,   381,    -1,   659,   371,
     372,   381,    -1,   659,    89,   666,   381,    -1,   369,    -1,
     370,    -1,    93,    -1,   294,    -1,   365,    -1,   366,    -1,
     367,    -1,   368,    -1,    -1,   233,   395,    -1,   335,   661,
      -1,   214,   455,    -1,   214,   291,   395,    -1,   270,   271,
     397,    -1,   270,   271,   214,   312,    -1,    -1,   663,   662,
     381,    -1,    -1,   385,   663,   386,    -1,    -1,   665,   451,
     664,    -1,   439,   376,    -1,   667,   440,   385,    -1,   668,
     441,   381,    -1,   668,    64,   311,   397,   381,    -1,   668,
     266,    79,   445,   381,    -1,   668,   672,   381,    -1,   146,
     400,    -1,   227,   398,   399,    -1,   670,   321,   395,    -1,
     670,    -1,   671,   670,    -1,   669,   227,   398,   399,    -1,
     669,   227,    20,    -1,   669,   378,   671,    -1,   669,   268,
     398,    -1,   669,   259,    -1,   669,   164,    -1,   669,   379,
      -1,   669,   380,    -1,   669,   377,    -1,   143,   376,   475,
       3,    -1,   381,    -1,   394,    -1,   405,    -1,   411,    -1,
     414,    -1,   428,    -1,   430,    -1,   433,    -1,   435,    -1,
     438,    -1,   676,    -1,   446,    -1,   512,    -1,   514,    -1,
     524,    -1,   415,    -1,   416,    -1,   417,    -1,   418,    -1,
     419,    -1,   420,    -1,   471,    -1,   472,    -1,   473,    -1,
     474,    -1,   476,    -1,   477,    -1,   478,    -1,   481,    -1,
     484,    -1,   487,    -1,   488,    -1,   489,    -1,   490,    -1,
     491,    -1,   492,    -1,   493,    -1,   494,    -1,   495,    -1,
     496,    -1,   497,    -1,   498,    -1,   501,    -1,   502,    -1,
     503,    -1,   504,    -1,   505,    -1,   506,    -1,   507,    -1,
     508,    -1,   509,    -1,   577,    -1,   613,    -1,   614,    -1,
     615,    -1,   616,    -1,   617,    -1,   618,    -1,   619,    -1,
     620,    -1,   673,    -1,   677,   386,    -1,   678,   386,    -1,
     457,   386,    -1,   566,    -1,   579,   386,    -1,   581,   386,
      -1,   623,   386,    -1,   629,    -1,   659,   386,    -1,   668,
     386,    -1,   423,   440,   385,    -1,   677,   441,   381,    -1,
     677,   424,   381,    -1,   677,   427,   381,    -1,   425,   440,
     385,    -1,   678,   441,   381,    -1,   678,   426,   381,    -1,
      77,    -1,    78,    -1,    80,    -1,    81,    -1,   139,    -1,
       5,    -1,   241,    -1,   238,    -1,   242,    -1,   240,    -1,
     239,    -1,   243,    -1,   244,    -1,   245,    -1,   264,    -1,
     265,    -1,   246,    -1,   279,    -1,   280,    -1,   281,    -1,
     282,    -1,   374,    -1,   375,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   720,   720,   721,   724,   726,   734,   743,   744,   745,
     752,   753,   754,   762,   763,   764,   765,   766,   767,   773,
     774,   781,   782,   786,   793,   794,   798,   802,   809,   817,
     818,   824,   833,   834,   838,   843,   844,   848,   849,   853,
     854,   858,   859,   860,   861,   862,   863,   864,   865,   866,
     872,   873,   882,   883,   884,   885,   888,   889,   890,   891,
     892,   893,   897,   904,   907,   914,   917,   920,   923,   927,
     928,   932,   933,   934,   942,   947,   948,   952,   959,   960,
     966,   971,   975,   989,  1003,  1004,  1008,  1009,  1010,  1021,
    1023,  1025,  1029,  1030,  1031,  1032,  1037,  1043,  1044,  1048,
    1056,  1060,  1062,  1068,  1069,  1076,  1077,  1081,  1087,  1091,
    1101,  1103,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,
    1115,  1116,  1117,  1118,  1122,  1123,  1124,  1125,  1129,  1130,
    1131,  1132,  1133,  1137,  1143,  1147,  1155,  1156,  1164,  1172,
    1173,  1174,  1178,  1179,  1183,  1188,  1189,  1193,  1195,  1203,
    1207,  1208,  1214,  1221,  1222,  1223,  1227,  1235,  1241,  1242,
    1243,  1247,  1248,  1252,  1253,  1254,  1255,  1256,  1257,  1263,
    1264,  1265,  1269,  1270,  1274,  1275,  1281,  1282,  1285,  1287,
    1291,  1292,  1296,  1314,  1315,  1316,  1317,  1318,  1319,  1327,
    1330,  1333,  1336,  1340,  1341,  1344,  1347,  1351,  1355,  1360,
    1366,  1373,  1378,  1383,  1388,  1392,  1396,  1400,  1410,  1418,
    1422,  1429,  1430,  1435,  1439,  1446,  1453,  1457,  1465,  1466,
    1467,  1472,  1476,  1479,  1480,  1481,  1482,  1483,  1484,  1485,
    1490,  1495,  1503,  1510,  1517,  1525,  1527,  1529,  1531,  1533,
    1535,  1537,  1540,  1544,  1550,  1551,  1552,  1556,  1557,  1563,
    1565,  1567,  1569,  1571,  1573,  1577,  1581,  1584,  1588,  1589,
    1590,  1594,  1595,  1596,  1604,  1604,  1614,  1618,  1619,  1620,
    1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,
    1651,  1662,  1663,  1670,  1671,  1678,  1687,  1691,  1695,  1719,
    1720,  1724,  1737,  1737,  1753,  1754,  1757,  1758,  1762,  1765,
    1774,  1787,  1788,  1789,  1790,  1794,  1795,  1796,  1797,  1798,
    1802,  1805,  1806,  1807,  1811,  1814,  1823,  1826,  1827,  1828,
    1829,  1833,  1834,  1835,  1839,  1840,  1841,  1842,  1846,  1847,
    1848,  1849,  1853,  1854,  1858,  1859,  1863,  1870,  1871,  1872,
    1873,  1880,  1881,  1884,  1885,  1892,  1904,  1905,  1909,  1910,
    1914,  1915,  1916,  1917,  1918,  1922,  1923,  1924,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1942,
    1943,  1953,  1957,  1980,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2007,  2008,  2009,  2010,  2011,  2012,
    2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,
    2024,  2025,  2026,  2028,  2030,  2032,  2034,  2035,  2036,  2037,
    2038,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2056,  2057,
    2062,  2085,  2086,  2087,  2088,  2089,  2090,  2094,  2097,  2098,
    2099,  2107,  2114,  2123,  2124,  2128,  2134,  2144,  2153,  2159,
    2164,  2171,  2176,  2182,  2183,  2184,  2192,  2193,  2194,  2195,
    2196,  2202,  2214,  2215,  2216,  2217,  2220,  2222,  2226,  2230,
    2241,  2242,  2243,  2244,  2245,  2246,  2249,  2251,  2254,  2256,
    2259,  2262,  2267,  2268,  2269,  2273,  2274,  2278,  2279,  2282,
    2301,  2307,  2331,  2332,  2333,  2334,  2335,  2345,  2346,  2347,
    2348,  2349,  2350,  2351,  2352,  2353,  2354,  2355,  2356,  2357,
    2358,  2359,  2360,  2361,  2362,  2363,  2364,  2365,  2366,  2367,
    2368,  2369,  2370,  2371,  2372,  2373,  2374,  2375,  2376,  2377,
    2378,  2379,  2384,  2385,  2386,  2387,  2388,  2389,  2390,  2391,
    2392,  2393,  2394,  2395,  2396,  2397,  2408,  2418,  2419,  2423,
    2424,  2425,  2426,  2427,  2428,  2429,  2432,  2447,  2450,  2452,
    2456,  2457,  2458,  2459,  2460,  2461,  2462,  2463,  2464,  2465,
    2465,  2466,  2466,  2467,  2468,  2469,  2473,  2474,  2478,  2486,
    2488,  2492,  2493,  2494,  2498,  2499,  2502,  2504,  2507,  2508,
    2509,  2510,  2511,  2512,  2513,  2514,  2515,  2516,  2517,  2520,
    2542,  2543,  2544,  2545,  2546,  2547,  2548,  2549,  2550,  2551,
    2552,  2553,  2554,  2555,  2556,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,
    2572,  2573,  2574,  2575,  2576,  2577,  2578,  2579,  2582,  2584,
    2587,  2589,  2598,  2600,  2601,  2604,  2606,  2610,  2611,  2614,
    2624,  2647,  2649,  2653,  2653,  2656,  2658,  2661,  2663,  2667,
    2671,  2672,  2677,  2680,  2683,  2688,  2691,  2696,  2699,  2703,
    2707,  2710,  2711,  2712,  2713,  2714,  2715,  2716,  2717,  2723,
    2730,  2731,  2732,  2737,  2738,  2744,  2754,  2755,  2756,  2757,
    2757,  2758,  2758,  2759,  2766,  2768,  2772,  2776,  2793,  2794,
    2795,  2796,  2797,  2798,  2799,  2800,  2801,  2802,  2807,  2808,
    2808,  2809,  2809,  2810,  2811,  2815,  2833,  2835,  2838,  2840,
    2844,  2847,  2860,  2861,  2862,  2863,  2868,  2876,  2884,  2886,
    2889,  2891,  2895,  2899,  2909,  2914,  2915,  2916,  2920,  2932,
    2934,  2938,  2939,  2943,  2956,  2961,  2962,  2963,  2967,  2979,
    2981,  2985,  2986,  2991,  2992,  2996,  2997,  3003,  3010,  3011,
    3012,  3013,  3014,  3015,  3016,  3017,  3018,  3019,  3020,  3021,
    3022,  3026,  3027,  3028,  3033,  3034,  3035,  3036,  3037,  3040,
    3041,  3042,  3043,  3044,  3045,  3046,  3049,  3051,  3054,  3056,
    3060,  3072,  3079,  3086,  3087,  3088,  3089,  3090,  3093,  3102,
    3110,  3117,  3118,  3122,  3127,  3133,  3136,  3141,  3142,  3143,
    3144,  3145,  3148,  3155,  3155,  3155,  3155,  3155,  3155,  3155,
    3155,  3155,  3155,  3155,  3155,  3155,  3155,  3155,  3156,  3156,
    3156,  3156,  3156,  3156,  3156,  3156,  3156,  3156,  3156,  3156,
    3156,  3156,  3156,  3156,  3156,  3156,  3156,  3156,  3156,  3156,
    3156,  3156,  3156,  3156,  3156,  3156,  3156,  3156,  3156,  3156,
    3156,  3156,  3156,  3156,  3156,  3156,  3156,  3156,  3156,  3156,
    3156,  3156,  3156,  3156,  3157,  3157,  3157,  3157,  3157,  3157,
    3157,  3157,  3157,  3157,  3158,  3158,  3158,  3158,  3159,  3159,
    3159,  3160,  3160,  3160,  3160,  3160,  3161,  3161,  3162,  3163,
    3164,  3165,  3166,  3167,  3168,  3169,  3170,  3171,  3172,  3172,
    3172,  3172,  3172,  3172
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "S", "MS", "US", "LOG", "SYSLOG", "ALL",
  "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL",
  "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD", "SHORT", "LONG",
  "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT", "CONFIGURE",
  "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES",
  "GRACEFUL", "RESTART", "KRT_SOURCE", "KRT_METRIC", "TABLE",
  "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID", "PROTOCOL", "TEMPLATE",
  "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT", "EXPORT",
  "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE", "LIMIT", "ACTION",
  "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED", "PASSWORD", "FROM",
  "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES",
  "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS", "PREEXPORT", "GENERATE",
  "ROA", "MAX", "FLUSH", "AS", "LISTEN", "BGP", "V6ONLY", "DUAL",
  "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN",
  "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC",
  "CLASS", "DSCP", "WAIT", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS",
  "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "EVAL", "ECHO", "ENABLE", "FUNCTION", "PRINT", "PRINTN",
  "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP",
  "PREFIX", "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK", "BGPPATH",
  "CLIST", "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT",
  "RO", "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE",
  "SCOPE", "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED",
  "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST", "MATCH", "ROA_CHECK",
  "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX", "INTERVAL",
  "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL", "SESSIONS", "HOLD",
  "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF",
  "DEFAULT", "PATH", "METRIC", "START", "DELAY", "FORGET", "AFTER",
  "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "PATHS", "AWARE",
  "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG",
  "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2",
  "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD", "TYPE",
  "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "SIMPLE", "AUTHENTICATION", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "LINK", "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG",
  "EXTERNAL", "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY",
  "GLOBAL", "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "TOPOLOGY",
  "STATE", "PIPE", "PEER", "MODE", "OPAQUE", "TRANSPARENT", "RADV", "RA",
  "MANAGED", "OTHER", "CONFIG", "MTU", "REACHABLE", "RETRANS", "TIMER",
  "CURRENT", "VALID", "PREFERRED", "MULT", "LIFETIME", "SKIP", "ONLINK",
  "AUTONOMOUS", "RDNSS", "DNSSL", "NS", "DOMAIN", "TRIGGER", "SENSITIVE",
  "RIP", "INFINITY", "PERIOD", "GARBAGE", "MULTICAST", "QUIET", "NOLISTEN",
  "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC",
  "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE",
  "';'", "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'",
  "$accept", "config", "conf_entries", "definition", "expr", "expr_us",
  "bool", "ipa", "ipa_scope", "prefix", "prefix_or_ipa", "pxlen",
  "datetime", "text_or_none", "log_config", "syslog_name", "log_file",
  "log_mask", "log_mask_list", "log_cat", "mrtdump_base",
  "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name",
  "cfg_timeout", "kern_proto_start", "kern_item", "kif_proto_start",
  "kif_item", "kern_sys_item", "rtrid", "idval", "listen", "listen_opts",
  "listen_opt", "gr_opts", "tab_sorted", "newtab", "roa_table_start",
  "roa_table_opts", "roa_table", "proto_start", "proto_name", "proto_item",
  "imexport", "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_or_preexport", "cmd_SHOW_ROA",
  "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT",
  "proto_patt", "proto_patt2", "filter_def", "$@1", "filter_eval", "type",
  "one_decl", "decls", "declsn", "filter_body", "filter", "where_filter",
  "function_params", "function_body", "function_def", "$@2", "cmds",
  "cmds_int", "block", "fipa", "set_atom", "switch_atom", "pair_expr",
  "pair_atom", "pair_item", "ec_expr", "ec_kind", "ec_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_iface_start", "bfd_iface_item", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_patt_list", "$@5",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "opttext",
  "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@6", "$@7", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@8", "$@9", "radv_iface_finish",
  "radv_iface_opts", "radv_iface_opt_list", "radv_iface",
  "radv_prefix_start", "radv_prefix_item", "radv_prefix_finish",
  "radv_prefix_opts", "radv_prefix_opt_list", "radv_prefix",
  "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_cfg_start", "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,    59,    40,    41,    58,   123,   125,    44,    63,    91,
      93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   391,   392,   392,   393,   393,   394,   395,   395,   395,
     396,   396,   396,   397,   397,   397,   397,   397,   397,   398,
     398,   399,   399,   400,   401,   401,   402,   402,   403,   404,
     404,   405,   406,   406,   407,   407,   407,   408,   408,   409,
     409,   410,   410,   410,   410,   410,   410,   410,   410,   410,
     411,   411,   412,   412,   412,   412,   413,   413,   413,   413,
     413,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     421,   422,   422,   422,   423,   424,   424,   424,   424,   424,
     425,   426,   426,   427,   428,   428,   429,   429,   429,   430,
     431,   431,   432,   432,   432,   432,   433,   434,   434,   435,
     436,   437,   437,   438,   438,   439,   439,   440,   440,   440,
     441,   441,   441,   441,   441,   441,   441,   441,   441,   441,
     441,   441,   441,   441,   442,   442,   442,   442,   443,   443,
     443,   443,   443,   444,   444,   445,   446,   446,   447,   448,
     448,   448,   449,   449,   450,   451,   451,   452,   453,   454,
     455,   455,   456,   457,   457,   457,   458,   459,   460,   460,
     460,   461,   461,   462,   462,   462,   462,   462,   462,   463,
     463,   463,   464,   464,   465,   465,   466,   466,   467,   467,
     468,   468,   469,   470,   470,   470,   470,   470,   470,   471,
     472,   473,   474,   475,   475,   476,   477,   478,   479,   479,
     479,   479,   479,   479,   479,   479,   479,   479,   479,   479,
     479,   480,   480,   481,   482,   482,   482,   482,   483,   483,
     483,   484,   485,   485,   485,   485,   485,   485,   485,   485,
     486,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   499,   499,   500,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   510,
     510,   511,   511,   511,   513,   512,   514,   515,   515,   515,
     515,   515,   515,   515,   515,   515,   515,   515,   515,   515,
     516,   517,   517,   518,   518,   519,   520,   520,   521,   522,
     522,   523,   525,   524,   526,   526,   527,   527,   528,   528,
     529,   530,   530,   530,   530,   531,   531,   531,   531,   531,
     532,   533,   533,   533,   534,   534,   535,   536,   536,   536,
     536,   537,   537,   537,   538,   538,   538,   538,   539,   539,
     539,   539,   540,   540,   541,   541,   542,   543,   543,   543,
     543,   544,   544,   545,   545,   545,   546,   546,   547,   547,
     548,   548,   548,   548,   548,   549,   549,   549,   550,   550,
     550,   550,   550,   550,   550,   550,   550,   550,   550,   551,
     551,   552,   553,   554,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   556,   556,   556,   556,   556,   556,
     556,   556,   556,   556,   556,   556,   556,   556,   556,   556,
     556,   556,   556,   556,   556,   556,   556,   556,   556,   556,
     556,   556,   556,   556,   556,   556,   556,   556,   556,   556,
     556,   557,   557,   557,   557,   557,   557,   558,   559,   559,
     559,   560,   560,   561,   561,   562,   562,   562,   562,   562,
     562,   562,   562,   562,   562,   562,   562,   562,   562,   562,
     562,   563,   564,   564,   564,   564,   565,   565,   566,   567,
     568,   568,   568,   568,   568,   568,   569,   569,   570,   570,
     571,   572,   573,   573,   573,   574,   574,   575,   575,   576,
     577,   578,   579,   579,   579,   579,   579,   579,   579,   579,
     579,   579,   579,   579,   579,   579,   579,   579,   579,   579,
     579,   579,   579,   579,   579,   579,   579,   579,   579,   579,
     579,   579,   579,   579,   579,   579,   579,   579,   579,   579,
     579,   579,   579,   579,   579,   579,   579,   579,   579,   579,
     579,   579,   579,   579,   579,   579,   580,   581,   581,   582,
     582,   582,   582,   582,   582,   582,   583,   584,   585,   585,
     586,   586,   586,   586,   586,   586,   586,   586,   586,   587,
     586,   588,   586,   586,   586,   586,   589,   589,   590,   591,
     591,   592,   592,   592,   593,   593,   594,   594,   595,   595,
     595,   595,   595,   595,   595,   595,   595,   595,   595,   596,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   598,   598,
     599,   600,   601,   601,   601,   602,   602,   603,   603,   604,
     605,   606,   606,   608,   607,   609,   609,   610,   610,   611,
     612,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   621,   621,   621,   621,   621,   621,   621,   621,   622,
     623,   623,   623,   623,   623,   624,   625,   625,   625,   626,
     625,   627,   625,   625,   628,   628,   629,   630,   631,   631,
     631,   631,   631,   631,   631,   631,   631,   631,   631,   632,
     631,   633,   631,   631,   631,   634,   635,   635,   636,   636,
     637,   638,   639,   639,   639,   639,   639,   640,   641,   641,
     642,   642,   643,   644,   645,   646,   646,   646,   647,   648,
     648,   649,   649,   650,   651,   652,   652,   652,   653,   654,
     654,   655,   655,   656,   656,   657,   657,   658,   659,   659,
     659,   659,   659,   659,   659,   659,   659,   659,   659,   659,
     659,   660,   660,   660,   661,   661,   661,   661,   661,   662,
     662,   662,   662,   662,   662,   662,   663,   663,   664,   664,
     665,   666,   667,   668,   668,   668,   668,   668,   669,   670,
     670,   671,   671,   672,   672,   672,   672,   672,   672,   672,
     672,   672,   673,   674,   674,   674,   674,   674,   674,   674,
     674,   674,   674,   674,   674,   674,   674,   674,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   676,   676,   676,   676,   676,   676,
     676,   676,   676,   676,   677,   677,   677,   677,   678,   678,
     678,   679,   679,   679,   679,   679,   679,   679,   679,   679,
     679,   679,   679,   679,   679,   679,   679,   679,   679,   679,
     679,   679,   679,   679
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       0,     4,     2,     0,     1,     2,     1,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     3,     1,     1,     1,     1,     2,     4,     3,     3,
       3,     3,     3,     4,     5,     3,     3,     4,     2,     0,
       1,     0,     1,     2,     2,     2,     3,     2,     3,     3,
       2,     3,     3,     3,     4,     5,     1,     1,     1,     4,
       0,     2,     2,     2,     1,     1,     5,     0,     1,     3,
       3,     0,     8,     1,     4,     1,     1,     0,     1,     3,
       0,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       4,     2,     3,     2,     2,     1,     1,     1,     0,     2,
       2,     2,     2,     2,     1,     1,     3,     3,     0,     1,
       1,     2,     0,     1,     3,     1,     3,     1,     0,     2,
       2,     2,     2,     3,     3,     3,     0,     3,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     4,     1,     0,     3,
       4,     1,     2,     0,     5,     5,     5,     5,     4,     3,
       3,     4,     5,     1,     0,     3,     4,     4,     0,     2,
       3,     3,     3,     2,     2,     2,     2,     3,     3,     2,
       2,     1,     1,     4,     0,     3,     3,     3,     0,     1,
       1,     4,     0,     2,     2,     2,     2,     2,     2,     2,
       0,     2,     9,     9,     4,     3,     3,     3,     3,     3,
       3,     3,     3,     4,     1,     1,     3,     0,     1,     3,
       3,     3,     3,     4,     4,     4,     4,     2,     1,     1,
       1,     1,     0,     1,     0,     4,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     0,     3,     1,     3,     1,     1,     1,     2,     3,
       2,     4,     0,     5,     0,     1,     1,     2,     1,     3,
       1,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     3,     1,     5,    11,     1,     1,     1,     2,
       1,     7,     9,     7,     1,     1,     1,     3,     1,     1,
       1,     3,     1,     3,     1,     3,     3,     1,     2,     2,
       6,     1,     3,     0,     4,     3,     1,     3,     3,     3,
       2,     2,     2,     2,     0,     2,     2,     0,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     1,     1,     5,
       7,     0,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     4,
       1,     1,     1,     1,     2,     2,     3,     3,     6,     3,
       3,     3,     3,     5,     6,     6,     6,     6,     4,     8,
       4,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       3,     1,     3,     0,     1,     4,     6,     4,     3,     5,
       5,     4,     6,     3,     2,     5,     5,     8,     8,     8,
       8,     2,     1,     2,     2,     2,     0,     3,     5,     0,
       2,     4,     4,     4,     2,     2,     0,     3,     0,     3,
       3,     2,     0,     2,     2,     0,     2,     0,     2,     4,
       5,     2,     3,     3,     5,     6,     7,     6,     4,     4,
       5,     6,     6,     5,     3,     3,     4,     5,     5,     5,
       5,     5,     4,     4,     5,     5,     5,     5,     5,     5,
       5,     5,     6,     6,     8,     6,     6,     5,     4,     5,
       4,     5,     4,     5,     4,     5,     5,     5,     5,     6,
       5,     5,     6,     5,     5,     4,     2,     3,     3,     1,
       2,     3,     2,     4,     2,     1,     2,     4,     0,     3,
       2,     1,     2,     3,     3,     3,     3,     2,     3,     0,
       5,     0,     5,     2,     2,     1,     4,     1,     1,     0,
       3,     2,     2,     2,     5,     2,     0,     3,     0,     2,
       2,     3,     2,     2,     3,     2,     2,     2,     1,     3,
       2,     2,     2,     2,     2,     2,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     2,     3,
       2,     3,     3,     4,     2,     2,     2,     3,     3,     3,
       2,     3,     3,     3,     4,     2,     2,     1,     0,     2,
       3,     1,     0,     1,     2,     0,     2,     0,     1,     3,
       0,     0,     2,     0,     3,     0,     3,     0,     3,     3,
       1,     0,     4,     6,     6,     6,     7,     6,     7,     5,
       0,     2,     3,     2,     3,     3,     2,     3,     2,     2,
       3,     3,     5,     4,     4,     2,     1,     2,     2,     0,
       3,     0,     3,     2,     0,     3,     5,     0,     4,     4,
       3,     2,     3,     3,     3,     3,     4,     4,     2,     0,
       3,     0,     3,     3,     3,     0,     0,     3,     0,     3,
       4,     1,     2,     2,     2,     4,     4,     0,     0,     3,
       0,     3,     3,     1,     0,     0,     2,     2,     0,     0,
       3,     1,     5,     1,     0,     0,     2,     2,     0,     0,
       3,     1,     5,     1,     2,     0,     2,     2,     3,     3,
       4,     4,     4,     5,     5,     4,     3,     4,     4,     4,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     2,     2,     3,     3,     4,     0,     3,     0,     3,
       0,     3,     2,     3,     3,     5,     5,     3,     2,     3,
       3,     1,     2,     4,     3,     3,     3,     2,     2,     2,
       2,     2,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     1,     2,     2,
       2,     1,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    69,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   371,     0,     0,
     818,   819,   820,   821,   822,   823,   824,   825,   826,   827,
     828,   829,   830,   831,   832,   833,   834,   835,   836,   837,
     838,   839,   840,   841,   842,   843,   844,   845,   846,   847,
     848,   849,   850,   851,   852,   853,   854,   855,   856,   857,
     858,   859,   860,   861,   862,   863,     3,     1,     2,     0,
       0,     0,     0,     0,     0,     0,   105,   106,     0,     0,
       0,     0,   371,     0,   803,   804,   805,   806,   807,   107,
     107,   808,   809,   810,   811,   103,   812,     0,   814,   107,
     110,   815,   816,   817,   107,   867,   107,   110,   107,   110,
     107,   110,   107,   871,   107,   110,   107,   110,     5,   813,
     110,   110,   258,   260,   259,     0,    70,    69,     0,     0,
      69,    71,    68,     0,     0,   230,     0,     0,     0,     0,
     257,   262,     0,   214,     0,     0,   198,   222,     0,   194,
     194,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     354,   358,   367,   364,   300,   373,   361,     0,     0,   357,
     371,   403,     0,     0,     0,   359,   360,     0,     0,     0,
     371,     0,   362,   363,   368,   401,   402,     0,   400,     0,
     245,   244,     0,   247,     0,     0,    34,    33,    36,     0,
       0,     0,    55,    54,    53,    52,     0,     0,     0,    97,
       0,   264,     0,    90,     0,     0,   266,   292,   108,     0,
       0,   101,    74,    80,   152,   481,   451,   536,   669,   675,
     747,   782,     0,     0,     0,     0,     0,    18,   156,     0,
       0,     0,     0,     0,   866,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    18,     0,     0,     0,     0,    18,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    18,     0,     0,     0,     0,     0,
       0,     0,     0,    18,     0,   868,     0,     0,     0,    18,
       0,     0,    18,   869,   539,     0,     0,   545,     0,     0,
       0,   870,     0,     0,     0,     0,   780,     0,     0,     0,
       0,     0,     0,     0,     0,   872,     0,     0,   177,   181,
       0,     0,     0,     0,   873,     0,     0,     0,     0,    18,
       0,    18,     0,     0,   864,     0,     0,     0,     0,    30,
     865,     0,     0,   159,   158,     0,     0,    71,    65,    66,
       0,    72,     0,   251,   249,     0,     0,     0,     0,   252,
     170,   169,     0,     0,   261,   263,   262,     0,   195,     0,
     218,   190,   189,     0,     0,   194,   193,   194,   194,   660,
     194,   194,     0,     0,    19,    20,     0,     0,     0,   240,
     241,   237,   235,   236,   238,   239,   354,   373,   354,   371,
     354,   354,     0,   346,     0,   371,     0,     0,     0,   357,
     357,     0,   398,   371,   371,   371,   371,   371,     0,   317,
     318,     0,   320,     0,     0,     7,   304,   302,     9,   371,
     301,   303,   326,   324,   325,   332,     0,   337,   341,     0,
     886,   881,   882,   883,   884,   374,   885,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   888,   891,   890,   887,
     889,   892,   893,   894,   897,   895,   896,   898,   899,   900,
     901,   902,   903,   404,   405,   242,   371,   371,   371,   371,
     371,   371,   371,   371,   371,   371,   371,   371,   371,     0,
      41,    42,    43,    44,    45,    46,    47,    48,    49,     0,
      39,   248,     0,   250,   371,     0,    35,    37,     0,     0,
     136,   371,   137,    56,     0,     0,    62,     0,    98,    99,
      86,    87,    88,   148,     0,   281,   100,     0,    51,     0,
       0,     0,   874,   878,     0,   153,   113,   135,   121,     0,
     111,    14,    16,    15,    17,    13,   112,   138,   126,   281,
     127,     0,     0,   371,   115,   125,     0,   116,     0,   123,
     114,   154,   155,   456,   482,     0,     0,    18,   494,     0,
       0,     0,     0,    18,     0,    18,     0,     0,   495,     0,
      21,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      18,     0,     0,     0,     0,    18,     0,    18,     0,    18,
       0,    18,     0,     0,    18,    18,    18,     0,     0,   483,
     537,   546,   540,    18,   544,   542,   538,   548,   670,     0,
       0,     0,   671,   684,   748,     0,   138,     0,   182,     0,
     178,   763,   761,   762,     0,     0,     0,     0,     0,     0,
       0,   749,   756,   183,   783,    18,   788,     0,   784,   798,
       0,   797,     0,   801,     0,   799,   800,   787,     0,    75,
       0,    77,    18,    18,   876,   877,   875,     0,    29,     0,
     880,   879,   164,   163,   165,   167,   168,   166,     0,   161,
     255,     0,    67,    73,    63,   231,   234,   253,   254,   174,
     175,     0,   172,   256,     0,   191,   196,   213,     0,   220,
       0,   219,     0,   197,   204,     0,     0,   212,   281,   206,
     205,   209,   210,     0,   211,   199,     0,   203,   221,   229,
     223,   226,   227,   225,   228,   224,     0,   651,   651,     0,
     194,   651,   194,   651,   652,   802,     0,     0,    23,     0,
       0,   350,   351,     0,   352,   353,   348,   336,   431,   434,
       0,   411,     0,   412,   355,   356,   349,     0,     0,     0,
       0,     0,     0,   319,   371,   384,   371,   313,   311,     0,
       0,   310,     0,     0,   365,   338,   339,     0,     0,   366,
     396,   394,   392,   389,   390,   391,   393,   395,   397,   385,
     386,   387,   388,   406,     0,   407,   409,   410,   246,     0,
     243,     0,    32,     0,    31,     0,     0,    58,    59,    60,
      61,     0,   138,     0,    84,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,     0,     0,     0,
     265,   285,    94,    95,     0,     0,    89,    91,    50,     0,
     281,   109,     0,   104,   122,   142,   145,   157,   286,   287,
     124,   134,   128,   118,    18,   288,   119,   117,   110,     0,
       0,     0,     0,     0,    18,   520,   522,     0,     0,     0,
       0,    18,     0,     0,   535,   496,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     488,     0,   489,     0,   518,     0,     0,     0,     0,     0,
       0,     0,   502,   503,     0,     0,     0,   524,     0,   541,
       0,     0,     0,   673,   674,   110,     0,   778,   760,   751,
       0,     0,   755,   750,   752,     0,   758,   759,   757,     0,
       0,     0,     0,     0,     0,   794,    21,   796,     0,   791,
     795,    83,    76,    78,    79,    81,    25,    24,    82,   160,
       0,    64,   171,     0,   192,   217,   216,   215,   201,   208,
     202,   200,   207,   480,   650,     0,     0,   659,   668,     0,
     666,     0,     0,   663,   661,     0,   651,     0,   651,     0,
      26,    27,     0,     0,   347,   371,   420,     0,   371,   371,
     371,   399,   371,   418,   371,     0,     0,   371,   371,   371,
       8,   300,   327,   333,     0,     0,   342,   371,    40,     6,
      38,    57,    96,   149,    85,   280,   279,   281,   371,    92,
      93,   290,   283,     0,   293,     0,   143,     0,   138,     0,
     133,   120,   459,   459,     0,   458,   452,     0,     0,     0,
       0,   531,   530,     0,   521,   525,   526,   527,     0,   517,
     511,    22,     0,   484,     0,   490,     0,   493,     0,   498,
     497,   510,   509,   504,     0,     0,   519,   507,   499,   500,
     501,   523,   533,   506,   505,   534,   508,   528,     0,   543,
     640,    18,     0,    18,   559,     0,     0,   561,   551,    18,
     547,     0,   565,   641,   672,   687,     0,   679,   681,     0,
     686,   676,     0,   754,   776,   781,   176,   178,   753,     0,
       0,     0,     0,     0,   180,   785,   786,   793,    21,     0,
     792,   162,   173,   654,   653,   667,   662,   664,   665,     0,
     655,     0,   657,     0,     0,   432,   413,     0,     0,     0,
       0,     0,   371,   369,   312,   310,     0,     0,   316,     0,
       0,   282,     0,   424,     0,   425,   426,     0,   371,   422,
     423,   421,   371,   371,     0,   371,     0,     0,   371,   296,
       0,   289,     0,   139,   140,   144,   146,   131,   129,   130,
     132,   138,   453,   468,   454,   472,   455,   457,     0,   513,
     532,   515,   516,     0,   485,   492,   491,   512,   487,   529,
     138,   564,   552,     0,     0,    18,     0,   550,     0,     0,
     568,   563,   567,     0,     0,   557,   549,     0,   575,   138,
     677,   711,   720,   678,     0,     0,   683,   685,   769,   179,
     183,    28,     0,     0,     0,     0,   789,   790,   656,   658,
     230,   230,   417,   415,   416,   414,   371,     0,   314,   371,
       0,   408,   371,   371,   371,   371,     0,     0,     0,   291,
     297,     0,     0,   444,   427,   429,     0,   284,     0,   141,
     147,   468,   466,   471,     0,     0,   475,     0,   486,   643,
     647,   554,   555,   553,   556,   628,   589,   569,   628,   558,
     642,   576,   708,   718,   717,   724,   723,   731,   680,   733,
     734,   741,   682,     0,     0,     0,     0,   779,     0,   188,
     183,   183,   183,   183,     0,     0,     0,   370,     0,     0,
       0,   340,     0,     0,     0,     0,   438,   371,   343,   371,
     371,     0,   371,   443,     0,   470,     0,   473,   474,     0,
     477,   514,   641,   645,   649,     0,     0,     0,   578,   706,
     705,     0,   722,   729,   739,     0,     0,     0,   772,   770,
      18,   764,   765,   766,   767,   768,   771,   777,   184,   185,
     186,   187,   232,   233,   419,   371,   323,   371,   321,   437,
     372,   441,     0,   371,   435,   298,     0,     0,     0,     0,
       0,     0,     0,     0,   430,     0,    18,     0,     0,     0,
       0,   469,     0,   476,    18,   479,   644,     0,   560,   631,
     629,   632,    18,     0,    18,   566,     0,   562,     0,     0,
       0,     0,     0,     0,   574,   588,     0,     0,   710,     0,
       0,    18,    18,    18,   721,     0,   725,   735,   150,   151,
     773,     0,   774,     0,     0,     0,     0,   371,   371,   305,
     309,   307,   371,   445,   308,   330,   328,   329,   334,     0,
     440,   439,   371,   371,   371,   371,   446,   102,   465,     0,
       0,     0,     0,   460,   464,   467,   478,     0,     0,     0,
      18,     0,     0,     0,    18,    18,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   648,
     627,     0,   633,     0,     0,   572,   573,   571,   570,   582,
     580,   579,     0,     0,   583,   585,   586,   587,   577,     0,
       0,     0,     0,     0,    18,     0,     0,     0,     0,   699,
     701,   709,     0,     0,     0,   712,   713,   714,   719,     0,
       0,   728,     0,     0,     0,   738,     0,   775,   371,   322,
     442,   299,   436,   345,   310,     0,   371,     0,     0,     0,
       0,     0,     0,     0,     0,    10,    11,    12,    18,   594,
     635,   625,     0,     0,     0,   620,    18,   626,   610,   590,
     593,   591,     0,   608,     0,   595,   597,   598,   599,   600,
     601,   602,   603,   604,    18,   614,   615,   616,    18,   592,
       0,    18,   646,   634,   630,   581,   584,     0,   698,     0,
       0,     0,     0,   691,    18,     0,     0,     0,    18,     0,
      18,     0,   707,   745,   745,     0,   743,   727,   726,   732,
     730,   737,   736,   742,   740,     0,   306,   371,   331,   344,
     335,     0,     0,     0,     0,   461,   462,   463,   611,     0,
     618,   617,   619,   621,   622,     0,   623,   607,   596,   606,
     609,   612,   605,     0,   690,     0,   745,   693,   692,   694,
     695,     0,   703,   700,   704,   702,    18,   715,   716,   744,
     315,     0,   450,   448,   449,   447,   637,   613,   636,   624,
     689,   688,   697,   696,   746,   638,     0,   639
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    85,   545,  1473,   546,   386,   877,   947,
     948,   738,  1232,   669,    86,   506,   199,   509,   499,   500,
      87,   206,   207,    88,    20,    21,    22,    23,    24,    25,
     131,   352,    89,   335,    90,   341,   336,    91,   524,    92,
     527,   837,    93,   519,    94,    95,   534,    96,    97,   219,
     245,   554,  1030,   853,   538,    98,   845,  1175,  1027,   846,
    1270,  1271,   812,   813,  1358,    99,   100,   547,   246,   346,
     678,   679,   363,   691,   692,   317,   920,   318,   319,   932,
      26,    27,    28,    29,   382,    30,    31,    32,   373,   716,
      33,   370,   702,    34,   374,   356,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,   193,   502,
      47,    48,    49,    50,    51,    52,    53,    54,    55,   125,
     367,   101,   525,   102,   827,   828,   829,  1023,   849,   850,
     555,   840,   831,   103,   530,  1164,  1165,  1384,   182,   432,
    1455,   768,   769,   433,  1147,   770,   434,   435,  1458,   436,
    1459,   183,   438,   439,  1386,   401,   184,   402,   411,   185,
     186,   187,  1167,   188,   473,  1145,  1168,  1265,  1266,   749,
     750,  1169,   104,  1037,   858,   105,  1181,  1402,  1336,  1273,
    1182,  1184,  1276,  1340,  1405,  1186,    56,   106,   107,   108,
     109,   295,   296,   297,   911,  1091,  1208,  1213,  1211,  1212,
    1346,  1416,  1092,  1348,  1426,  1093,  1501,  1345,  1410,  1411,
    1504,  1649,  1696,  1688,  1200,  1218,  1280,  1342,  1407,  1344,
    1201,   965,    57,    58,    59,    60,    61,    62,    63,    64,
     729,   110,   111,   112,  1102,  1224,  1225,   915,   113,  1219,
    1532,  1619,  1621,  1428,  1427,  1350,  1220,  1222,  1435,  1352,
    1351,  1294,  1223,  1297,  1353,  1542,  1629,  1436,  1298,  1301,
    1354,  1546,  1633,  1437,  1302,  1627,  1677,   114,   115,   634,
    1366,  1308,  1228,  1105,   626,   627,   116,   117,   326,   939,
     940,   327,    65,   118,    66,   119,   120,   121,   474
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1393
static const yytype_int16 yypact[] =
{
     101,  2690,   118,   702,   386,   755,   169,   386,   386,   121,
     725,   386,   246,   948,   146,   201,   851,  1709,    54,   386,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,   137,
     634,   189,   534,   249,   320,   274, -1393, -1393,   365,   349,
     319,   153,  1709,   392, -1393, -1393, -1393, -1393, -1393,   457,
     457, -1393, -1393, -1393, -1393,    87, -1393,   462, -1393,   457,
    2587, -1393, -1393, -1393,   457, -1393,   457,  2320,   457,  1044,
     457,  2430,   457, -1393,   457,  2136,   457,  2509, -1393, -1393,
    2361,  2537, -1393, -1393, -1393,   114, -1393,   471,   495,   502,
     471,   448, -1393,   517,   543,   500,   386,   386,   546,   142,
   -1393,   518,   162, -1393,   571,   581, -1393, -1393,   370,   202,
     578,   673,   673,   626,   639,   648,   652,   668,   674,   685,
      13, -1393, -1393, -1393,   645,   316, -1393,   493,    48,     1,
    1709, -1393,   335,   343,   352, -1393, -1393,   355,   359,   374,
     929,    37, -1393, -1393, -1393, -1393, -1393,  2109, -1393,  2840,
   -1393, -1393,  1243,   691,   763,   751, -1393,   722, -1393,   -12,
     114,   159, -1393, -1393, -1393, -1393,   496,   404,   657,   689,
     465, -1393,   787, -1393,   441,   142,  2874, -1393,   719,   450,
     476, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393,   478,   114,   823,   796,   159,   473, -1393,   887,
     544,   759,   883,   142, -1393,   540,   545,   539,   549,   -61,
     853,   562,   717,   937,   473,   869,   684,   -44,   840,   473,
     133,   673,   298,   898,   746,   903,   754,   758,   470,   748,
     756,   501,   734,   747,   473,   745,   760,   757,   -22,    12,
     781,   775,   750,   473,   797, -1393,   642,   644,   737,   473,
     949,   159,   473, -1393, -1393,   649,   666, -1393,   672,   975,
     453, -1393,   679,   681,   683,   993, -1393,  1049,   159,   687,
     -27,   159,   159,  1004,  -115, -1393,   698,   699, -1393,   696,
     697,   778,   673,  1011, -1393,   712,   425,   718,  1019,   473,
    1029,   473,  1027,  1026, -1393,   723,   726,   727,  1035,  1089,
   -1393,   739,   740, -1393, -1393,   976,  1115,   448, -1393, -1393,
    1116,   159,  1119, -1393, -1393,  1105,  1124,  1125,  1130, -1393,
   -1393, -1393,   130,  1134, -1393, -1393,   773,  1135, -1393,  1136,
     433, -1393, -1393,  1810,  1335,   578, -1393,   578,   578, -1393,
     235,   402,  1139,  1140, -1393, -1393,    20,  1024,  1028, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393,    13, -1393,    13,  1709,
      13,    13,  1143, -1393,  1145,  1463,  1123,   942,  1132,     1,
       1,  1133,  1129,  1709,  1709,  1709,  1709,  1709,  1146, -1393,
   -1393,  1149, -1393,   788,    98, -1393, -1393, -1393, -1393,   849,
   -1393, -1393,  1171, -1393, -1393, -1393,   -19,    42, -1393,   167,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393,  1709,  1709,  1709,  1709,
    1709,  1709,  1709,  1709,  1709,  1709,  1709,  1709,  1709,   906,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,   410,
   -1393, -1393,  1184, -1393,  1709,  1173, -1393, -1393,  1243,   813,
   -1393,  1709, -1393,   159,   770,   794, -1393,   159, -1393, -1393,
   -1393, -1393, -1393, -1393,   815,  1664, -1393,   116, -1393,   816,
     818,  1179, -1393, -1393,   -20, -1393, -1393, -1393, -1393,   737,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,  1537,
   -1393,   149,  1099,  1709, -1393, -1393,   149, -1393,   149, -1393,
   -1393, -1393, -1393, -1393, -1393,  1137,  1138,    43, -1393,  1162,
     831,   832,   159,   124,   965,   473,   673,   852, -1393,   858,
    1200,   159,  1118,   159,  1163,   159,  1170,    -1,   159,   159,
     473,  1180,   863,  1169,   872,   473,   873,   473,   263,   473,
     823,   473,   874,   875,   473,   473,   473,   876,  1147, -1393,
   -1393, -1393, -1393,   473, -1393,  1174, -1393, -1393, -1393,  1249,
     893,   894, -1393, -1393, -1393,   159, -1393,   895, -1393,   899,
    1201, -1393, -1393, -1393,   926,   927,   928,   159,   933,   935,
     936, -1393, -1393,   340, -1393,   473, -1393,   823, -1393, -1393,
     594, -1393,   673, -1393,  1083, -1393, -1393, -1393,   159, -1393,
     159, -1393,   473,   473, -1393, -1393, -1393,   159, -1393,   673,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,   424, -1393,
   -1393,  1316, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393,   506, -1393, -1393,  1317, -1393, -1393, -1393,  1302, -1393,
    1308, -1393,   673, -1393, -1393,  1306,  1307, -1393,  1537, -1393,
   -1393, -1393, -1393,   673, -1393, -1393,  1311, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393,  1328,  1313,  1313,   917,
     578,  1313,   578,  1313, -1393, -1393,   159,   673, -1393,  1319,
    1320, -1393, -1393,   862, -1393, -1393, -1393, -1393,   171, -1393,
     953, -1393,  1312, -1393, -1393, -1393, -1393,   261,   286,   324,
     890,   598,  -179, -1393,  1709, -1393,  1709, -1393,  1333,   954,
     955,   984,    68,    75, -1393, -1393, -1393,  1329,  1325, -1393,
    1195,  1195,  1195,  1762,  1762,  1195,  1195,  1195,  1195,   675,
     675,  1129,  1129, -1393,   966, -1393, -1393, -1393, -1393,  1243,
   -1393,  1985, -1393,   552, -1393,   984,  1331, -1393, -1393, -1393,
   -1393,   971, -1393,   972, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393,   109,   977,   974,
   -1393, -1393, -1393, -1393,   673,   159, -1393, -1393, -1393,  1014,
    1664, -1393,   673, -1393, -1393,  1330, -1393,   969, -1393, -1393,
   -1393, -1393,  1263, -1393,   473,  2874, -1393, -1393,  2522,   159,
     159,   159,   982,   985,   473, -1393, -1393,   988,   989,   992,
     997,   473,   998,   999, -1393, -1393,  1346,  1259,  1001,   159,
    1006,   159,  1007,   159,  1008,  1009,  1010,  1013,  1015,   159,
   -1393,   737, -1393,  1020, -1393,  1034,  1036,  1037,  1043,  1045,
    1047,  1048, -1393, -1393,  1053,  1055,  1056, -1393,   147, -1393,
     159,  1884,  1057, -1393, -1393,  2155,  1058,   157, -1393, -1393,
    1030,  1059, -1393, -1393, -1393,  1061, -1393, -1393, -1393,   159,
     533,   669,  1039,  1063,  1068, -1393,  1200, -1393,   673,  1064,
    1083, -1393, -1393, -1393, -1393, -1393,    20, -1393, -1393, -1393,
     976, -1393, -1393,   130, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393,  1392,  1397, -1393, -1393,   737,
   -1393,   737,  1435, -1393, -1393,   737,  1313,  1448,  1313,  1450,
   -1393, -1393,  1336,  1338, -1393,  1709, -1393,  1428,  1709,  1709,
    1709, -1393,  1709, -1393,  1709,   635,  1016,  1709,  1485,  1709,
   -1393, -1393, -1393, -1393,  1074,   645, -1393,  1709, -1393, -1393,
   -1393, -1393, -1393,   969, -1393, -1393, -1393,  1664,   600, -1393,
   -1393, -1393,  1081,  1080, -1393,  1344, -1393,   752, -1393,   805,
   -1393, -1393, -1393, -1393,   673, -1393, -1393,  1084,  1079,  1086,
    1088, -1393, -1393,  1091, -1393, -1393, -1393, -1393,  1092, -1393,
   -1393, -1393,   159, -1393,  1096, -1393,  1104, -1393,  1106, -1393,
   -1393, -1393, -1393, -1393,  1107,  1110, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,  1114, -1393,
   -1393,   473,   317,    97, -1393,  1175,   673, -1393, -1393,   287,
   -1393,  1126, -1393,  1172, -1393, -1393,   673, -1393, -1393,   673,
   -1393, -1393,  1127, -1393, -1393, -1393, -1393,  1201, -1393,  1128,
    1477,  1477,  1477,  1477, -1393, -1393, -1393, -1393,  1200,   159,
    1064, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,  1503,
   -1393,  1507, -1393,  1500,  1502, -1393, -1393,  1144,  1238,  1274,
    1571,   704,  1709, -1393, -1393,  2874,  1142,  1131,  2874,  1504,
    1650, -1393,    26, -1393,  1498, -1393, -1393,  1141,  1709, -1393,
   -1393, -1393,  1709,  1709,  1151,    27,  2109,  1157,  1516, -1393,
    1664, -1393,  1506,   673, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393,  1154, -1393,    58, -1393, -1393,   159, -1393,
   -1393, -1393, -1393,  1160, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393,   159,   159,   473,   159, -1393,  1159,   737,
   -1393, -1393,  1161,  1165,   159, -1393, -1393,   159,  1166, -1393,
   -1393, -1393,  1167, -1393,     0,     9, -1393, -1393,   216, -1393,
     340, -1393,  1176,  1177,  1178,  1181, -1393, -1393, -1393, -1393,
     500,   500, -1393, -1393, -1393, -1393,  1709,  1722,  1519,  1609,
    1168, -1393,  1709,  1463,  1709, -1393,  2012,  2676,   822, -1393,
   -1393,  1531,   332, -1393,  2874,  1182,  1183, -1393,  1406, -1393,
     969,  1154, -1393, -1393,  1541,  1543,  1341,  1186, -1393,   969,
    1187, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393,  1189, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393,   252,   159,  1294,   356, -1393,  1194, -1393,
     340,   340,   340,   340,  1565,  1573,  1751, -1393,  1196,  1202,
       3, -1393,  2037,  1204,  2084,  2096, -1393,  1891, -1393,  1709,
    1709,   467,  1516, -1393,  1569, -1393,    36, -1393, -1393,   673,
    1371, -1393,  1172, -1393, -1393,     5,    -5,    16,   524, -1393,
   -1393,   579, -1393, -1393, -1393,   159,   159,   159, -1393, -1393,
     326, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393,  1709, -1393,  1709, -1393, -1393,
   -1393, -1393,  1206,   600,  1410, -1393,    21,  2113,  2138,  1219,
    1222,  1223,  1224,  1226, -1393,  1228,   473,   738,  1396,   159,
     159, -1393,  1232, -1393,   473, -1393, -1393,  2506, -1393, -1393,
   -1393,   115,   473,   159,   473, -1393,  1233, -1393,   159,   159,
     159,  1380,   136,   -26, -1393, -1393,  1235,  2386, -1393,  1266,
    1267,   473,   473,   473, -1393,  1242,   138,   214, -1393, -1393,
   -1393,  1318, -1393,  1244,  1236,  1251,  1253,  1891,    55, -1393,
   -1393, -1393,   849, -1393, -1393,  1634, -1393, -1393, -1393,   212,
   -1393, -1393,  1709,  1709,  1709,  1709, -1393, -1393, -1393,  1427,
    1429,  1430,   801, -1393, -1393, -1393, -1393,  1332,   159,  1264,
     473,  1337,   234,  1381,   473,   473,   159,   159,   159,  1416,
     159,   186,  1112,  1324,    24,  1358,   159,  1334,  1362, -1393,
   -1393,  1286, -1393,   159,  1290, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393,   159,   159, -1393, -1393, -1393, -1393, -1393,  1342,
     673,    40,  1339,  1340,   473,  1345,  1613,  1343,  1451,  1466,
    1471, -1393,  1315,   159,   159, -1393, -1393, -1393, -1393,    96,
     673, -1393,  1321,    96,  1673, -1393,  1356, -1393,  1709, -1393,
   -1393, -1393, -1393, -1393,  1795,   120,    55,   129,  1853,  1909,
    1934,  1960,   159,   159,   159, -1393, -1393, -1393,   473, -1393,
   -1393, -1393,    44,   159,   159, -1393,   419, -1393, -1393, -1393,
   -1393, -1393,   159, -1393,   159, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393,   473, -1393, -1393, -1393,   473, -1393,
     159,   473, -1393, -1393, -1393, -1393, -1393,  1479, -1393,   159,
    1482,   159,   159, -1393,   473,   159,   159,  1601,   473,     0,
     473,     9, -1393,  1350,  1350,   159, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393,  1359, -1393,  1709, -1393, -1393,
   -1393,  1360,  1372,  1374,  1375, -1393, -1393, -1393, -1393,    32,
   -1393, -1393, -1393, -1393, -1393,  1405, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393,   159, -1393,   159,  1350, -1393, -1393, -1393,
   -1393,   159, -1393, -1393, -1393, -1393,   473, -1393, -1393, -1393,
   -1393,  1795, -1393, -1393, -1393, -1393,  1412, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393,  1383, -1393
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1393, -1393, -1393, -1393,  -141,  -667,   -28,  -236,  -906,  -146,
    -699, -1393,  -204, -1393, -1393, -1393, -1393, -1393,  1212,   922,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
     538,  1418, -1393, -1393, -1393, -1393, -1393, -1393,  -286, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,  1968,
    -100,  1499, -1393,   222,  -355, -1393, -1393, -1393, -1393,   715,
    -544,   547, -1393, -1393,   270, -1393, -1393, -1393, -1393,   144,
   -1393,   817,   289, -1393,   828, -1194,   661,  -617, -1393,  -730,
   -1393, -1393, -1393, -1393,  -142, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393,  -358, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,   671,
    1403, -1393, -1393, -1393, -1393,  -792,   765,   627,  1271,  1090,
    1426, -1393,   960, -1393, -1393, -1121, -1393,   361,  -180,  1038,
     247,  -985,   827, -1335, -1047,  1631, -1290,  1041,   258, -1393,
   -1393,  -177,  1065, -1393, -1393, -1393, -1393,   299,   554, -1393,
   -1393,  -996, -1393,   -31,   660,   -17, -1393, -1393,   505,   859,
     595, -1067, -1393, -1393, -1393, -1393,   814, -1393, -1393,   580,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393,   561, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393,   508, -1393, -1393, -1393, -1393,
   -1393,  -503, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,
   -1393, -1393,   334,   315, -1393, -1393, -1393, -1393,   237,   322,
   -1393, -1393, -1393, -1393,   238,   325, -1392, -1393, -1393, -1393,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393,   920,
   -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1393, -1102
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -434
static const yytype_int16 yytable[] =
{
     189,   431,   611,   847,   437,   387,   388,   286,   383,   294,
    1377,   302,  1144,   921,   961,   316,   409,   325,   384,   385,
     337,   342,  1166,   384,   385,   580,   582,  1448,   396,  1299,
    1117,   507,   397,  -295,   384,   385,  1449,  1450,  1451,  1001,
     430,   398,  -295,  -295,  -295,  -295,  1152,  1022,  1252,   736,
    1686,  1456,   425,   426,   427,   164,   428,   600,   425,   425,
     512,  -294,   428,   428,  1262,   216,   631,  1515,   775,   776,
    -294,  -294,  -294,  -294,  1152,   407,  1153,   541,   542,   543,
     544,   565,   917,   425,   426,   427,  1001,   428,  1274,   190,
     425,   426,   427,  1001,   428,   540,  1457,   191,  1260,   842,
     602,   884,   574,   638,  1153,     1,   476,   477,   478,   479,
     480,   425,   425,  1154,   861,   428,   428,  1595,    67,   579,
     481,   482,   483,   484,   485,   486,   487,   488,  1015,   403,
     489,   541,   542,   543,   544,  1449,  1450,  1451,  1001,   425,
    1412,  1154,  1396,   428,  1449,  1450,  1451,  1001,   425,   343,
     614,   425,   428,   412,  1425,   428,   195,   344,   541,   542,
     543,   544,   425,   424,   425,   368,   428,   629,   428,  1166,
     635,   636,   132,   214,   425,   566,   646,   360,   428,   476,
     477,   478,   479,   480,   851,   361,  1155,  1156,  1157,  1158,
    1159,  1160,  1161,   481,   482,   483,   484,   485,   486,   487,
     488,   425,  1320,   489,   993,   428,  1162,   575,   994,  1163,
     683,   601,  1236,  1500,  1155,  1156,  1157,  1158,  1159,  1160,
    1161,   376,  1456,  1382,   689,   966,   571,   715,   977,   885,
     979,   577,  1678,   726,  1162,   727,   728,  1163,   731,   733,
     135,   832,   833,   834,   835,   900,   596,  1397,  1398,   140,
    1513,  1399,  1400,   844,   376,   607,   408,   639,   640,  1325,
    1385,   612,  1446,   215,   615,   151,   690,  1457,  1013,   476,
     477,   478,   479,   480,  1692,  1609,  1516,  1275,   730,  1517,
     603,  1413,  1016,   481,   482,   483,   484,   485,   486,   487,
     488,   377,   934,   489,   476,   477,   478,   479,   480,   200,
    1584,   659,   425,   661,  1414,   201,   428,   369,   481,   482,
     483,   484,   485,   486,   487,   488,   384,   385,   489,   862,
     152,   541,   542,   543,   544,   208,  1596,  1553,  1174,  1597,
    1444,  1166,   476,   477,   478,   479,   480,   868,   869,   209,
     873,   425,   632,   633,   510,   428,   481,   482,   483,   484,
     485,   486,   487,   488,  1330,   378,   489,   210,  1650,  1651,
     541,   542,   543,   544,  1331,   403,   843,   403,   773,   403,
     403,   774,   806,   508,  1355,  1356,   811,   536,  1022,  1610,
    1385,  1415,   743,  1206,   211,  1295,  1378,  1166,   748,   410,
    1443,  1408,  1355,  1356,  1300,   399,   757,   758,   759,   760,
     761,   400,  1417,  1452,   737,   122,   123,  1453,  1253,  -295,
     852,   217,   771,  -295,   936,   852,   937,   852,  1687,   429,
     581,   376,  1401,   929,  1502,   511,   511,   777,   212,   124,
    1303,   867,  1503,   946,   425,  1639,   697,  -294,   428,   192,
     878,  -294,   880,   213,   882,   732,  1625,   886,   887,  1304,
     511,  1166,  1166,   541,   542,   543,   544,   429,   930,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   792,   221,  1129,  1269,  1131,   218,   946,   511,   511,
     520,   765,   521,   522,   916,   766,  1305,   801,   425,  1539,
     921,   126,   428,   896,   805,  1540,   925,   836,   348,   345,
    1309,   981,  1637,   931,   529,   349,   511,   541,   542,   543,
     544,  1452,   698,   351,   578,   511,   513,   941,   511,   942,
     353,   379,   897,   898,  1541,  1573,   945,   362,  1077,   511,
     222,   511,   560,   380,   381,   223,   855,   364,   365,   863,
    1441,   511,  1104,  1357,  1028,   870,   354,   872,   699,   359,
     224,  1306,   514,   515,   778,   700,   957,   779,   985,  1389,
    1166,   366,   888,  1635,  1574,  1543,   701,   893,   511,   895,
     523,   899,  1544,   901,   371,   202,   904,   905,   906,   355,
    1368,  1369,  1370,  1371,   372,   909,   225,   548,   976,   649,
     978,   375,   431,   431,   203,   980,  1556,   376,  1019,  1557,
    1545,   437,  1307,  1203,  1204,  1065,   476,   477,   478,   479,
     480,  1214,   384,   385,   935,  1390,  1391,   933,   204,  1152,
     481,   482,   483,   484,   485,   486,   487,   488,   307,   389,
     489,   430,   430,  1655,   943,   944,   549,   550,  1110,  1205,
    1111,   556,   390,   476,   477,   478,   479,   480,   988,  1153,
    1361,   391,   650,   309,   196,   392,  1279,   481,   482,   483,
     484,   485,   486,   487,   488,   347,  1418,   489,   350,   511,
    1392,   393,   226,   989,   404,  1393,   197,   394,   133,   134,
     205,   138,   139,  1125,   651,  1126,  1154,   198,   395,  1128,
     194,   384,   385,   652,  1020,   741,  1025,   742,   405,   744,
     745,   406,  1118,   487,   488,    68,   501,   489,   511,   588,
     589,   990,   476,   477,   478,   479,   480,   413,  1038,  1039,
    1040,  1362,  1363,  1364,  1365,   414,   481,   482,   483,   484,
     485,   486,   487,   488,   415,    69,   489,   416,  1054,   227,
    1056,   417,  1058,    70,   122,   123,    71,   995,  1064,   996,
     592,   593,   520,   553,   521,   522,   418,    72,  1036,  1155,
    1156,  1157,  1158,  1159,  1160,  1161,   503,  1078,   124,  1079,
     384,   385,  1173,   504,  1112,   126,  1113,    73,   856,  1162,
     857,    74,  1163,   505,    75,   516,    76,    77,  1109,   620,
     621,   946,   364,   365,    78,   228,   798,   799,  1185,   517,
     229,   511,   653,   654,   655,   656,   526,   357,   358,   127,
     949,   950,  1419,  1420,  1421,  1101,  1422,   128,   129,   130,
     518,    79,   528,   230,   531,    80,  1031,  1423,   807,   808,
     476,   477,   478,   479,   480,   532,  1043,    81,   231,  1565,
    1566,  1567,   537,  1048,   481,   482,   483,   484,   485,   486,
     487,   488,   809,   810,   489,   511,   558,    82,   136,   137,
      83,   533,   160,   535,   161,   162,   163,   164,   165,   166,
     476,   477,   478,   479,   480,   167,   168,   767,   169,   539,
     170,  1177,  1314,  1315,   481,   482,   483,   484,   485,   486,
     487,   488,   952,   953,   489,  1645,  1646,  1647,   476,   477,
     478,   479,   480,   559,  1178,  1179,  1180,  1233,  1234,  1235,
    1424,  1193,   481,   482,   483,   484,   485,   486,   487,   488,
     967,   561,   489,  1286,   563,   153,   562,  1429,  1430,   567,
     548,  1431,  1432,  1433,   564,   171,   968,   946,  1010,   799,
    1210,   172,   160,   568,   161,   162,   163,   164,   165,   166,
    1221,  1469,  1470,  1226,   569,   167,   168,   570,   169,   573,
     170,   154,   155,   754,   755,  1434,   572,   576,   748,   583,
     584,  1137,  1138,  1139,   585,  1140,   586,  1141,  1237,   549,
     550,   590,  1148,   594,   551,   992,  -294,   587,  1296,   552,
    1150,   591,   476,   477,   478,   479,   480,   173,   174,   969,
     595,   597,   156,   157,   158,   159,   481,   482,   483,   484,
     485,   486,   487,   488,   604,   171,   489,   608,   598,   606,
     599,   172,  1142,   609,   476,   477,   478,   479,   480,   610,
     616,   613,   175,   176,   419,   420,   421,   422,   481,   482,
     483,   484,   485,   486,   487,   488,   605,  1277,   489,   177,
     672,   617,   178,  1202,   619,  1207,   179,   618,   141,   142,
     622,  1215,  1281,  1282,   625,  1284,   623,   143,   624,   628,
     673,   674,   630,  1289,   793,   637,  1290,   173,   174,   641,
     642,   643,   644,    84,   675,   676,   144,   677,   233,   645,
     647,  1246,   145,   648,   146,   147,   553,   794,   658,   657,
     660,   662,   663,  1403,   664,   795,   667,   665,   666,   668,
     796,   797,   175,   176,   419,   420,   421,   422,   680,   682,
     670,   671,   684,   234,   685,  1247,   235,   686,   687,   177,
     236,   237,   178,   688,   239,   240,   179,   693,   695,   696,
     241,  1256,   734,   735,   739,  1257,  1258,   970,   740,   751,
     752,  1264,   476,   477,   478,   479,   480,   746,   148,   753,
     747,   489,   756,  1359,   763,   762,   481,   482,   483,   484,
     485,   486,   487,   488,   242,   764,   489,  1283,   772,   243,
     815,   816,   817,   818,   819,   820,   821,   800,   822,   823,
     824,   825,   826,   802,   804,   971,   814,   838,   841,  1409,
     839,  1409,   854,  -434,  -434,  -434,  1454,  1328,   859,   860,
     972,   864,   865,   866,  1438,  1439,  1440,  -434,  -434,  -434,
    -434,   485,   486,   487,   488,   149,   871,   489,   973,  1316,
     876,   180,  1148,   874,   881,  1322,   748,  1324,   181,   875,
     879,   883,   974,   975,   890,   984,   476,   477,   478,   479,
     480,   889,   891,   892,   894,   902,   903,   907,  1472,  1474,
     481,   482,   483,   484,   485,   486,   487,   488,   912,   908,
     489,   910,  1506,   991,   913,   914,   918,  1509,  1510,  1511,
     919,  1514,   476,   477,   478,   479,   480,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   481,   482,   483,   484,
     485,   486,   487,   488,  1296,   307,   489,   922,   923,   924,
     938,   180,  1387,  1388,   926,  1264,   927,   928,   181,   951,
     954,   955,   288,   956,   150,   958,   959,   289,   290,   291,
     962,   963,  1442,   964,   982,   983,   986,  1569,   718,   987,
     997,   998,   999,  1005,  1004,  1579,  1580,  1581,  1007,  1583,
    1585,  1011,  1012,  1014,   719,  1599,  1028,  1026,  1017,  1018,
    1148,  1029,  1603,  1041,   292,  1051,  1042,  1000,  1468,  1044,
    1045,  1605,  1606,  1046,  1221,  1454,  1476,  1454,  1047,  1049,
    1050,  1052,  1053,  1296,  1505,  1119,  1507,  1055,  1057,  1059,
    1060,  1061,  1623,  1624,  1062,  1123,  1063,  1021,  1626,  1143,
    1124,  1066,  1626,  1535,  1536,  1537,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,   720,  1067,  1106,  1068,  1069,   721,
     722,  1472,  1472,  1472,  1070,  1114,  1071,   723,  1072,  1073,
     293,  1652,  1653,  1654,  1074,  1554,  1075,  1076,  1094,  1103,
    1107,  1657,  1108,  1658,  1115,  1558,  1559,  1560,  1561,  1116,
    1127,  1130,  1571,  1132,   724,  1136,  1577,  1578,  1133,  1661,
    1134,  1149,  1170,  1171,  1172,  1187,  1188,  1189,  1664,  1190,
    1666,  1667,  1191,  1192,  1669,  1670,   160,  1194,   161,   162,
     163,   164,   165,   166,  1679,  1195,  1209,  1196,  1197,   167,
     168,  1198,   169,   725,   170,  1199,  1613,  1231,   160,  1217,
     161,   162,   163,   164,   165,   166,  1238,  1216,  1227,  1230,
    1239,   167,   168,   767,   169,  1240,   170,  1241,  1249,  1250,
    1254,  1268,  1690,  1255,  1691,  1248,  1318,  1242,  1334,   160,
    1693,   161,   162,   163,   164,   165,   166,  1259,  1263,  1272,
    1648,  1278,   167,   168,  1285,   169,  1287,   170,  1656,   171,
    1288,  1291,  1293,  1329,  1321,   172,   848,  1310,  1311,  1312,
    1337,  1339,  1313,  1338,  1333,  1360,  1659,  1341,  1372,  1332,
    1660,   171,  1343,  1662,  1349,  1367,  1373,   172,  1375,   476,
     477,   478,   479,   480,  1395,  1376,  1668,  1380,  1404,  1445,
    1672,  1447,  1674,   481,   482,   483,   484,   485,   486,   487,
     488,  1462,   171,   489,  1463,  1464,  1465,  1466,   172,  1467,
    1471,   173,   174,  1475,  1508,  1512,  1518,  1533,  1534,  1549,
    1681,  1243,   160,  1538,   161,   162,   163,   164,   165,   166,
    1547,  1548,  1550,   173,   174,   167,   168,  1319,   169,  1551,
     170,  1555,  1562,  1568,  1563,  1564,   175,   176,  1694,  1570,
    1572,  1582,  1576,  1594,  1598,  1600,  1601,  1244,   476,   477,
     478,   479,   480,   177,   173,   174,   178,  1602,   175,   176,
     179,  1604,   481,   482,   483,   484,   485,   486,   487,   488,
    1617,  1607,   489,  1612,  1615,   177,  1618,  1614,   178,  1616,
    1611,  1620,   179,  1299,  1663,   171,  1622,  1665,  1671,   175,
     176,   172,  1630,   815,   816,   817,   818,   819,   820,   821,
    1676,   822,   823,   824,   825,   826,   177,  1689,  1695,   178,
     803,  1008,   160,   179,   161,   162,   163,   164,   165,   166,
     476,   477,   478,   479,   480,   167,   168,  1634,   169,   557,
     170,  1682,  1680,  1176,   481,   482,   483,   484,   485,   486,
     487,   488,  1575,  1683,   489,  1684,  1685,   173,   174,   476,
     477,   478,   479,   480,  1697,   681,  1292,  1121,  1229,   694,
     476,   477,   478,   481,   482,   483,   484,   485,   486,   487,
     488,  1122,  1151,   489,   481,   482,   483,   484,   485,   486,
     487,   488,   175,   176,   489,   171,   830,  1267,   960,   717,
    1024,   172,  1638,   476,   477,   478,   479,   480,  1552,   177,
    1002,   423,   178,   703,  1003,  1640,   179,   481,   482,   483,
     484,   485,   486,   487,   488,  1146,  1261,   489,   384,   385,
     815,   816,   817,   818,   819,   820,   821,  1394,   822,   823,
     824,   825,   826,  1006,  1135,   180,  -433,  1183,  1323,  1347,
    1406,  1335,   181,   704,  1608,  1628,  1673,   173,   174,  1675,
    1120,   476,   477,   478,   479,   480,  1632,   180,  1631,     0,
       0,     0,     0,     0,   181,   481,   482,   483,   484,   485,
     486,   487,   488,     0,     0,   489,     0,     0,     0,   705,
       0,     0,   175,   176,   706,     0,     0,  -428,   180,     0,
       0,   707,   708,     0,     0,   181,     0,     0,     0,   177,
    1152,     0,   178,   709,     0,     0,   179,   476,   477,   478,
     479,   480,   710,   711,   712,   713,     0,   714,     0,     0,
       0,   481,   482,   483,   484,   485,   486,   487,   488,     0,
    1153,   489,   476,   477,   478,   479,   480,     0,     0,     0,
       0,     0,     0,     0,  1245,     0,   481,   482,   483,   484,
     485,   486,   487,   488,     0,     0,   489,     0,   476,   477,
     478,   479,   480,  1080,     0,     0,     0,  1154,     0,     0,
       0,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   180,   489,   476,   477,   478,   479,   480,   181,     0,
       0,     0,     0,     0,     0,     0,     0,   481,   482,   483,
     484,   485,   486,   487,   488,     0,     0,   489,     0,   553,
     476,   477,   478,   479,   480,     0,     0,     0,     0,  1081,
       0,     0,     0,  1251,   481,   482,   483,   484,   485,   486,
     487,   488,     0,     0,   489,   476,   477,   478,   479,   480,
    1155,  1156,  1157,  1158,  1159,  1160,  1161,     0,   220,   481,
     482,   483,   484,   485,   486,   487,   488,   232,     0,   489,
    1162,     0,   247,  1163,   248,     0,   287,     0,   298,     0,
     303,     0,   304,     0,   320,     0,     0,     0,     0,     0,
       0,   180,   476,   477,   478,   479,   480,     0,   181,     0,
       0,   440,     0,     0,     0,  1317,   481,   482,   483,   484,
     485,   486,   487,   488,   440,  1082,   489,     0,     0,     0,
       0,   476,   477,   478,   479,   480,     0,     0,     0,     0,
       0,     0,     0,     0,  1374,   481,   482,   483,   484,   485,
     486,   487,   488,     0,     0,   489,   476,   477,   478,   479,
     480,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     481,   482,   483,   484,   485,   486,   487,   488,  1083,     0,
     489,     0,     0,   441,   442,     0,   443,   444,  1636,     0,
     233,     0,     0,     0,     0,     0,   441,   442,     0,   443,
     444,     0,  1084,     0,  1085,     0,     0,     0,     0,   233,
    1086,   305,  1087,     0,     0,     0,  1088,  1089,     0,     0,
       0,     0,     0,     0,   445,   234,     0,     0,   235,     0,
       0,     0,   236,   237,     0,   306,   239,   240,     0,     0,
       0,     0,   241,     0,   234,   446,  1641,   235,     0,     0,
     307,   236,   237,     0,  1095,   239,   240,     0,   446,     0,
       0,   241,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   308,   309,   242,     0,     0,     0,
    1090,   243,     0,     0,     0,     0,  1383,     0,     0,     0,
       0,     0,     0,     0,     0,   242,     0,     0,     0,     0,
     243,     0,  1642,     0,     0,     0,     0,     0,   447,   448,
       0,   449,   450,   451,   452,   453,   454,   455,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1643,     0,     0,
       0,     0,     0,     0,  1096,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   456,   457,   458,   459,   460,   461,
     462,   463,   464,  1644,     0,     0,     0,   456,   457,   458,
     459,   460,   461,   462,   463,   464,     0,     0,     0,     0,
     465,   466,     0,     0,   233,     0,  1009,     0,     0,   249,
       0,     0,     0,   465,   466,   467,   468,   469,   470,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   467,   468,
     469,   470,     0,  1326,     0,   250,     0,     0,     0,   234,
       0,     0,   235,     0,     0,   233,   236,   237,   251,     0,
     239,   240,     0,     0,     0,     0,   241,     0,  1379,     0,
       0,   252,     0,     0,   253,     0,   254,     0,     0,   328,
     329,   330,     0,   331,   332,     0,   333,     0,     0,   310,
     234,     0,     0,   235,     0,     0,     0,   236,   237,     0,
     242,   239,   240,     0,     0,   243,     0,   241,     0,     0,
       0,     0,     0,     0,     0,  1381,   255,     0,   256,     0,
     471,   472,     0,     0,   233,     0,     0,   257,     0,     0,
       0,     0,     0,   471,   472,     0,     0,     0,     0,     0,
       0,   242,     0,     0,  1460,     0,   243,     0,   311,   312,
     313,     0,     0,     0,     0,     0,  1519,   314,     0,   234,
    1097,  1098,   235,   258,  1099,     0,   236,   237,     0,  1461,
     239,   240,   315,     0,     0,     0,   241,     0,     0,     0,
     259,     0,     0,     0,     0,     0,     0,   260,   261,     0,
     262,  1100,   263,   264,     0,   265,   266,     0,   267,     0,
       0,   268,   269,   233,   270,  1520,     0,     0,     0,     0,
     242,     0,     0,     0,     0,   243,   233,   271,   272,     0,
    1477,     0,   273,   321,   274,   275,     0,   276,     0,     0,
       0,   233,   277,     0,     0,     0,   278,   279,   234,   280,
     281,   235,   282,   283,   284,   236,   237,  1521,     0,   239,
     240,   234,     0,     0,   235,   241,     0,   338,   236,   237,
     307,  1032,   239,   240,     0,     0,   234,  1522,   241,   235,
       0,     0,     0,   236,   237,     0,     0,   239,   240,     0,
       0,   233,     0,   241,     0,   309,     0,     0,     0,   242,
       0,     0,     0,     0,   243,     0,     0,     0,  1478,   339,
       0,     0,   242,     0,     0,   322,     0,   243,     0,  1479,
       0,     0,     0,     0,     0,     0,   234,   242,     0,   235,
       0,     0,   243,   236,   237,     0,   238,   239,   240,     0,
       0,     0,     0,   241,   476,   477,   478,   479,   480,     0,
       0,     0,     0,     0,     0,     0,     0,  1523,   481,   482,
     483,   484,   485,   486,   487,   488,   285,     0,   489,     0,
       0,     0,     0,     0,     0,     0,  1480,   242,     0,  1481,
    1482,     0,   243,     0,     0,     0,  1524,  1525,     0,     0,
    1526,  1527,     0,  1528,     4,     0,     0,     0,     0,  1033,
    1034,  1529,  1530,     0,     0,     0,     0,   334,     0,     0,
       0,     0,     0,     0,     0,     0,     5,     6,     0,     0,
       0,     0,     0,     0,   299,   300,     7,     0,     0,     0,
       0,     0,  1531,     0,     0,   323,  1483,     0,     0,  1484,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1485,     8,  1486,     0,  1487,  1488,  1489,  1490,  1491,  1492,
       0,     0,     0,     0,     0,  1493,     0,     0,     0,  1494,
    1495,     9,     0,  1496,     0,     0,   301,     0,     0,     0,
       0,     0,    10,     0,     0,    11,  1497,    12,     0,     0,
       0,     0,     0,    13,  1498,     0,     0,     0,    14,    15,
      16,     0,     0,   475,     0,    17,    18,    19,   476,   477,
     478,   479,   480,     0,     0,     0,  1327,     0,     0,     0,
       0,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,     0,   489,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   480,     0,     0,     0,
       0,     0,  1499,     0,     0,   324,   481,   482,   483,   484,
     485,   486,   487,   488,     0,     0,   489,     0,  1035,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   340,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   244
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1393)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-434)))

static const yytype_int16 yycheck[] =
{
      17,   181,   288,   547,   181,   151,   152,   107,   150,   109,
       7,   111,   997,   630,   713,   115,    15,   117,    18,    19,
     120,   121,  1018,    18,    19,   261,   262,     6,    15,    20,
     936,    43,    19,     6,    18,    19,    15,    16,    17,    18,
     181,    28,    15,    16,    17,    18,    19,   839,    22,    29,
      18,  1386,    15,    16,    17,    18,    19,    79,    15,    15,
     201,     6,    19,    19,  1166,    82,    93,    93,    26,    27,
      15,    16,    17,    18,    19,    27,    49,    34,    35,    36,
      37,   142,   626,    15,    16,    17,    18,    19,    30,    35,
      15,    16,    17,    18,    19,   236,  1386,    43,  1165,   119,
      88,   102,   146,   218,    49,     4,     8,     9,    10,    11,
      12,    15,    15,    86,    71,    19,    19,    93,     0,   260,
      22,    23,    24,    25,    26,    27,    28,    29,    19,   160,
      32,    34,    35,    36,    37,    15,    16,    17,    18,    15,
     145,    86,   106,    19,    15,    16,    17,    18,    15,    35,
     291,    15,    19,   170,  1348,    19,    19,    43,    34,    35,
      36,    37,    15,   180,    15,     3,    19,   308,    19,  1165,
     311,   312,     3,    20,    15,   236,   322,    35,    19,     8,
       9,    10,    11,    12,    35,    43,   159,   160,   161,   162,
     163,   164,   165,    22,    23,    24,    25,    26,    27,    28,
      29,    15,  1249,    32,   383,    19,   179,   251,   387,   182,
     351,   233,  1118,  1407,   159,   160,   161,   162,   163,   164,
     165,    19,  1557,  1325,    94,   728,   254,   373,   731,   230,
     733,   259,  1624,   375,   179,   377,   378,   182,   380,   381,
     119,   125,   126,   127,   128,   600,   274,   211,   212,     3,
     114,   215,   216,   539,    19,   283,   208,   372,   373,  1255,
    1327,   289,  1383,   110,   292,   119,   136,  1557,   812,     8,
       9,    10,    11,    12,  1666,   235,   302,   219,    43,   305,
     268,   286,   173,    22,    23,    24,    25,    26,    27,    28,
      29,    89,   647,    32,     8,     9,    10,    11,    12,   110,
     114,   329,    15,   331,   309,   116,    19,   145,    22,    23,
      24,    25,    26,    27,    28,    29,    18,    19,    32,   276,
     119,    34,    35,    36,    37,    76,   302,  1448,  1027,   305,
    1377,  1327,     8,     9,    10,    11,    12,   213,   214,    19,
     576,    15,   369,   370,   200,    19,    22,    23,    24,    25,
      26,    27,    28,    29,    22,   153,    32,    83,   314,   315,
      34,    35,    36,    37,    32,   396,   386,   398,   387,   400,
     401,   390,   513,   385,   140,   141,   517,   233,  1170,   339,
    1447,   386,   399,   286,    19,   385,   383,  1383,   405,   388,
    1375,   386,   140,   141,   385,   382,   413,   414,   415,   416,
     417,   388,   386,   382,   384,    19,    20,   386,   382,   382,
     551,    19,   429,   386,   650,   556,   652,   558,   386,   382,
     122,    19,   386,    83,   309,   382,   382,   385,    79,    43,
     214,   572,   317,   669,    15,  1556,     3,   382,    19,   385,
     581,   386,   583,   124,   585,    43,   350,   588,   589,   233,
     382,  1447,  1448,    34,    35,    36,    37,   382,   118,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   385,   976,  1173,   978,    19,   713,   382,   382,
      15,   383,    17,    18,   625,   387,   270,   504,    15,   351,
    1107,    20,    19,   230,   511,   357,   637,   381,     3,   385,
    1230,   737,   382,   163,   215,     3,   382,    34,    35,    36,
      37,   382,    79,    65,   381,   382,    20,   658,   382,   660,
       3,   319,   259,   260,   386,   291,   667,   385,   381,   382,
      68,   382,   243,   331,   332,    73,   553,    19,    20,   567,
     214,   382,   385,   291,   387,   573,     3,   575,   115,     3,
      88,   335,    56,    57,   387,   122,   702,   390,   387,    92,
    1556,    43,   590,  1548,   330,   351,   133,   595,   382,   597,
     105,   599,   358,   601,     3,    41,   604,   605,   606,    79,
    1310,  1311,  1312,  1313,     3,   613,   124,    43,   730,   164,
     732,   221,   772,   773,    60,   736,   384,    19,   834,   387,
     386,   778,   386,   286,   287,   891,     8,     9,    10,    11,
      12,   324,    18,    19,    20,   148,   149,   645,    84,    19,
      22,    23,    24,    25,    26,    27,    28,    29,   104,     3,
      32,   772,   773,   214,   662,   663,    92,    93,   105,   322,
     107,    97,     3,     8,     9,    10,    11,    12,   387,    49,
     294,     3,   227,   129,    20,     3,  1200,    22,    23,    24,
      25,    26,    27,    28,    29,   127,   142,    32,   130,   382,
     203,     3,   210,   387,    29,   208,    42,     3,     7,     8,
     146,    10,    11,   969,   259,   971,    86,    53,     3,   975,
      19,    18,    19,   268,   835,   396,   842,   398,   382,   400,
     401,   208,   938,    28,    29,     3,    15,    32,   382,   239,
     240,   387,     8,     9,    10,    11,    12,   382,   859,   860,
     861,   365,   366,   367,   368,   382,    22,    23,    24,    25,
      26,    27,    28,    29,   382,    33,    32,   382,   879,   277,
     881,   382,   883,    41,    19,    20,    44,   764,   889,   766,
     249,   250,    15,   209,    17,    18,   382,    55,   858,   159,
     160,   161,   162,   163,   164,   165,     3,   908,    43,   910,
      18,    19,    20,    22,   105,    20,   107,    75,   556,   179,
     558,    79,   182,    61,    82,   381,    84,    85,   929,   336,
     337,  1027,    19,    20,    92,   333,   386,   387,  1034,   142,
     338,   382,   377,   378,   379,   380,    19,   136,   137,    54,
     386,   387,   288,   289,   290,   915,   292,    62,    63,    64,
     131,   119,   381,   361,   105,   123,   854,   303,    58,    59,
       8,     9,    10,    11,    12,   385,   864,   135,   376,    38,
      39,    40,    19,   871,    22,    23,    24,    25,    26,    27,
      28,    29,    58,    59,    32,   382,    97,   155,   133,   134,
     158,   385,    13,   385,    15,    16,    17,    18,    19,    20,
       8,     9,    10,    11,    12,    26,    27,    28,    29,    83,
      31,    76,  1240,  1241,    22,    23,    24,    25,    26,    27,
      28,    29,   386,   387,    32,  1562,  1563,  1564,     8,     9,
      10,    11,    12,    20,    99,   100,   101,  1111,  1112,  1113,
     386,  1052,    22,    23,    24,    25,    26,    27,    28,    29,
       3,   381,    32,  1209,   385,    74,   381,   348,   349,    76,
      43,   352,   353,   354,   385,    86,    19,  1173,   386,   387,
    1086,    92,    13,   381,    15,    16,    17,    18,    19,    20,
    1096,   213,   214,  1099,   237,    26,    27,    20,    29,   275,
      31,   110,   111,   409,   410,   386,    97,   127,   985,    71,
     224,   988,   989,   990,    71,   992,   222,   994,  1119,    92,
      93,   233,   999,   249,    97,   387,   386,   229,  1224,   102,
    1007,   235,     8,     9,    10,    11,    12,   148,   149,    82,
     253,   256,   151,   152,   153,   154,    22,    23,    24,    25,
      26,    27,    28,    29,   233,    86,    32,   220,   258,   269,
     263,    92,   387,   381,     8,     9,    10,    11,    12,   385,
     381,    82,   183,   184,   185,   186,   187,   188,    22,    23,
      24,    25,    26,    27,    28,    29,   271,  1188,    32,   200,
      74,   385,   203,  1081,    79,  1083,   207,   385,   110,   111,
     381,  1089,  1203,  1204,    71,  1206,   385,   119,   385,    20,
      94,    95,   385,  1214,   168,    71,  1217,   148,   149,   381,
     381,   385,   385,   381,   108,   109,   138,   111,    44,   311,
      79,   387,   144,   381,   146,   147,   209,   191,    79,   381,
      71,    74,    76,  1339,   381,   199,    71,   381,   381,    20,
     204,   205,   183,   184,   185,   186,   187,   188,     3,     3,
     381,   381,     3,    79,    19,  1142,    82,     3,     3,   200,
      86,    87,   203,     3,    90,    91,   207,     3,     3,     3,
      96,  1158,     3,     3,   120,  1162,  1163,   230,   120,    26,
     208,  1168,     8,     9,    10,    11,    12,    14,   210,    27,
      15,    32,    29,  1304,    15,    19,    22,    23,    24,    25,
      26,    27,    28,    29,   130,   387,    32,  1205,     7,   135,
     166,   167,   168,   169,   170,   171,   172,     3,   174,   175,
     176,   177,   178,    20,   381,   278,   381,   381,    19,  1345,
     382,  1347,   103,     8,     9,    10,  1386,   385,    71,    71,
     293,    49,   381,   381,  1355,  1356,  1357,    22,    23,    24,
      25,    26,    27,    28,    29,   277,   261,    32,   311,  1246,
      30,   382,  1249,   381,    71,  1252,  1253,  1254,   389,   381,
     122,    71,   325,   326,   381,   383,     8,     9,    10,    11,
      12,    71,    83,   381,   381,   381,   381,   381,  1399,  1400,
      22,    23,    24,    25,    26,    27,    28,    29,    19,   122,
      32,    97,  1413,   383,   381,   381,   381,  1418,  1419,  1420,
     381,  1422,     8,     9,    10,    11,    12,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    22,    23,    24,    25,
      26,    27,    28,    29,  1540,   104,    32,   381,   381,   381,
     227,   382,  1329,  1330,   381,  1332,   381,   381,   389,     3,
       3,    19,   278,    15,   376,    19,    19,   283,   284,   285,
      19,     3,  1360,    20,    15,    15,   383,  1478,     3,    27,
       7,   387,   387,    18,    15,  1486,  1487,  1488,   382,  1490,
    1491,    20,   381,   381,    19,  1496,   387,    27,   381,   385,
    1377,    98,  1503,   381,   320,    19,   381,   383,  1396,   381,
     381,  1512,  1513,   381,  1520,  1555,  1404,  1557,   381,   381,
     381,   122,   381,  1619,  1412,   321,  1414,   381,   381,   381,
     381,   381,  1533,  1534,   381,     3,   381,   383,  1539,   383,
       3,   381,  1543,  1431,  1432,  1433,   294,   295,   296,   297,
     298,   299,   300,   301,    79,   381,   386,   381,   381,    84,
      85,  1562,  1563,  1564,   381,   386,   381,    92,   381,   381,
     386,  1572,  1573,  1574,   381,  1452,   381,   381,   381,   381,
     381,  1582,   381,  1584,   381,  1462,  1463,  1464,  1465,   381,
      15,     3,  1480,     3,   119,    27,  1484,  1485,   122,  1600,
     122,   387,   381,   383,   120,   381,   387,   381,  1609,   381,
    1611,  1612,   381,   381,  1615,  1616,    13,   381,    15,    16,
      17,    18,    19,    20,  1625,   381,   311,   381,   381,    26,
      27,   381,    29,   158,    31,   381,  1524,    20,    13,   327,
      15,    16,    17,    18,    19,    20,     3,   381,   381,   381,
       3,    26,    27,    28,    29,    15,    31,    15,   387,    15,
      22,    15,  1663,   382,  1665,   383,     7,   383,   122,    13,
    1671,    15,    16,    17,    18,    19,    20,   386,   381,   385,
    1568,   381,    26,    27,   385,    29,   385,    31,  1576,    86,
     385,   385,   385,    22,   386,    92,    19,   381,   381,   381,
      19,   220,   381,    20,   381,   271,  1594,   381,     3,   387,
    1598,    86,   385,  1601,   385,   381,     3,    92,   382,     8,
       9,    10,    11,    12,    15,   383,  1614,   383,   217,   383,
    1618,   181,  1620,    22,    23,    24,    25,    26,    27,    28,
      29,   382,    86,    32,   382,   382,   382,   381,    92,   381,
     214,   148,   149,   381,   381,   235,   381,   351,   351,   383,
    1637,   383,    13,   381,    15,    16,    17,    18,    19,    20,
     312,   387,   381,   148,   149,    26,    27,    28,    29,   386,
      31,     7,   215,   311,   215,   215,   183,   184,  1676,   385,
     313,   235,   271,   329,   296,   321,   294,   383,     8,     9,
      10,    11,    12,   200,   148,   149,   203,   381,   183,   184,
     207,   381,    22,    23,    24,    25,    26,    27,    28,    29,
     229,   339,    32,   343,    71,   200,   220,   342,   203,   346,
     351,   220,   207,    20,   215,    86,   381,   215,    97,   183,
     184,    92,   381,   166,   167,   168,   169,   170,   171,   172,
     360,   174,   175,   176,   177,   178,   200,   312,   306,   203,
     508,   799,    13,   207,    15,    16,    17,    18,    19,    20,
       8,     9,    10,    11,    12,    26,    27,   381,    29,   240,
      31,   381,   383,  1028,    22,    23,    24,    25,    26,    27,
      28,    29,  1482,   381,    32,   381,   381,   148,   149,     8,
       9,    10,    11,    12,   381,   347,  1219,   950,  1107,   366,
       8,     9,    10,    22,    23,    24,    25,    26,    27,    28,
      29,   953,  1017,    32,    22,    23,    24,    25,    26,    27,
      28,    29,   183,   184,    32,    86,   525,  1170,   708,   373,
     840,    92,  1555,     8,     9,    10,    11,    12,  1447,   200,
     772,   180,   203,     3,   773,  1557,   207,    22,    23,    24,
      25,    26,    27,    28,    29,   998,  1166,    32,    18,    19,
     166,   167,   168,   169,   170,   171,   172,  1332,   174,   175,
     176,   177,   178,   778,   985,   382,   383,  1033,  1253,  1288,
    1342,  1271,   389,    43,  1520,  1540,  1619,   148,   149,  1621,
     940,     8,     9,    10,    11,    12,  1544,   382,  1543,    -1,
      -1,    -1,    -1,    -1,   389,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,    -1,    -1,    -1,    79,
      -1,    -1,   183,   184,    84,    -1,    -1,   381,   382,    -1,
      -1,    91,    92,    -1,    -1,   389,    -1,    -1,    -1,   200,
      19,    -1,   203,   103,    -1,    -1,   207,     8,     9,    10,
      11,    12,   112,   113,   114,   115,    -1,   117,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      49,    32,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   383,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    -1,     8,     9,
      10,    11,    12,    89,    -1,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,   382,    32,     8,     9,    10,    11,    12,   389,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    -1,   209,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,   145,
      -1,    -1,    -1,   383,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,     8,     9,    10,    11,    12,
     159,   160,   161,   162,   163,   164,   165,    -1,    90,    22,
      23,    24,    25,    26,    27,    28,    29,    99,    -1,    32,
     179,    -1,   104,   182,   106,    -1,   108,    -1,   110,    -1,
     112,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,
      -1,   382,     8,     9,    10,    11,    12,    -1,   389,    -1,
      -1,     5,    -1,    -1,    -1,   383,    22,    23,    24,    25,
      26,    27,    28,    29,     5,   231,    32,    -1,    -1,    -1,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   383,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,   284,    -1,
      32,    -1,    -1,    77,    78,    -1,    80,    81,   383,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,    80,
      81,    -1,   308,    -1,   310,    -1,    -1,    -1,    -1,    44,
     316,    65,   318,    -1,    -1,    -1,   322,   323,    -1,    -1,
      -1,    -1,    -1,    -1,   105,    79,    -1,    -1,    82,    -1,
      -1,    -1,    86,    87,    -1,    89,    90,    91,    -1,    -1,
      -1,    -1,    96,    -1,    79,   139,   383,    82,    -1,    -1,
     104,    86,    87,    -1,    89,    90,    91,    -1,   139,    -1,
      -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   128,   129,   130,    -1,    -1,    -1,
     386,   135,    -1,    -1,    -1,    -1,   385,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,
     135,    -1,   383,    -1,    -1,    -1,    -1,    -1,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   383,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   383,    -1,    -1,    -1,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,    -1,    -1,    -1,
     264,   265,    -1,    -1,    44,    -1,   381,    -1,    -1,    49,
      -1,    -1,    -1,   264,   265,   279,   280,   281,   282,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,   280,
     281,   282,    -1,   381,    -1,    75,    -1,    -1,    -1,    79,
      -1,    -1,    82,    -1,    -1,    44,    86,    87,    88,    -1,
      90,    91,    -1,    -1,    -1,    -1,    96,    -1,   381,    -1,
      -1,   101,    -1,    -1,   104,    -1,   106,    -1,    -1,    68,
      69,    70,    -1,    72,    73,    -1,    75,    -1,    -1,   303,
      79,    -1,    -1,    82,    -1,    -1,    -1,    86,    87,    -1,
     130,    90,    91,    -1,    -1,   135,    -1,    96,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   381,   146,    -1,   148,    -1,
     374,   375,    -1,    -1,    44,    -1,    -1,   157,    -1,    -1,
      -1,    -1,    -1,   374,   375,    -1,    -1,    -1,    -1,    -1,
      -1,   130,    -1,    -1,   381,    -1,   135,    -1,   362,   363,
     364,    -1,    -1,    -1,    -1,    -1,   120,   371,    -1,    79,
     355,   356,    82,   193,   359,    -1,    86,    87,    -1,   381,
      90,    91,   386,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     210,    -1,    -1,    -1,    -1,    -1,    -1,   217,   218,    -1,
     220,   386,   222,   223,    -1,   225,   226,    -1,   228,    -1,
      -1,   231,   232,    44,   234,   169,    -1,    -1,    -1,    -1,
     130,    -1,    -1,    -1,    -1,   135,    44,   247,   248,    -1,
      64,    -1,   252,    64,   254,   255,    -1,   257,    -1,    -1,
      -1,    44,   262,    -1,    -1,    -1,   266,   267,    79,   269,
     270,    82,   272,   273,   274,    86,    87,   211,    -1,    90,
      91,    79,    -1,    -1,    82,    96,    -1,    70,    86,    87,
     104,    89,    90,    91,    -1,    -1,    79,   231,    96,    82,
      -1,    -1,    -1,    86,    87,    -1,    -1,    90,    91,    -1,
      -1,    44,    -1,    96,    -1,   129,    -1,    -1,    -1,   130,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,   142,   112,
      -1,    -1,   130,    -1,    -1,   146,    -1,   135,    -1,   153,
      -1,    -1,    -1,    -1,    -1,    -1,    79,   130,    -1,    82,
      -1,    -1,   135,    86,    87,    -1,    89,    90,    91,    -1,
      -1,    -1,    -1,    96,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,    22,    23,
      24,    25,    26,    27,    28,    29,   386,    -1,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   210,   130,    -1,   213,
     214,    -1,   135,    -1,    -1,    -1,   340,   341,    -1,    -1,
     344,   345,    -1,   347,    44,    -1,    -1,    -1,    -1,   217,
     218,   355,   356,    -1,    -1,    -1,    -1,   386,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    -1,    -1,
      -1,    -1,    -1,    -1,   334,   335,    76,    -1,    -1,    -1,
      -1,    -1,   386,    -1,    -1,   266,   270,    -1,    -1,   273,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     284,   101,   286,    -1,   288,   289,   290,   291,   292,   293,
      -1,    -1,    -1,    -1,    -1,   299,    -1,    -1,    -1,   303,
     304,   121,    -1,   307,    -1,    -1,   386,    -1,    -1,    -1,
      -1,    -1,   132,    -1,    -1,   135,   320,   137,    -1,    -1,
      -1,    -1,    -1,   143,   328,    -1,    -1,    -1,   148,   149,
     150,    -1,    -1,     3,    -1,   155,   156,   157,     8,     9,
      10,    11,    12,    -1,    -1,    -1,   180,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,   386,    -1,    -1,   386,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    -1,   386,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   386,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   386
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   392,   393,    44,    66,    67,    76,   101,   121,
     132,   135,   137,   143,   148,   149,   150,   155,   156,   157,
     415,   416,   417,   418,   419,   420,   471,   472,   473,   474,
     476,   477,   478,   481,   484,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   577,   613,   614,   615,
     616,   617,   618,   619,   620,   673,   675,     0,     3,    33,
      41,    44,    55,    75,    79,    82,    84,    85,    92,   119,
     123,   135,   155,   158,   381,   394,   405,   411,   414,   423,
     425,   428,   430,   433,   435,   436,   438,   439,   446,   456,
     457,   512,   514,   524,   563,   566,   578,   579,   580,   581,
     622,   623,   624,   629,   658,   659,   667,   668,   674,   676,
     677,   678,    19,    20,    43,   510,    20,    54,    62,    63,
      64,   421,     3,   510,   510,   119,   133,   134,   510,   510,
       3,   110,   111,   119,   138,   144,   146,   147,   210,   277,
     376,   119,   119,    74,   110,   111,   151,   152,   153,   154,
      13,    15,    16,    17,    18,    19,    20,    26,    27,    29,
      31,    86,    92,   148,   149,   183,   184,   200,   203,   207,
     382,   389,   529,   542,   547,   550,   551,   552,   554,   556,
      35,    43,   385,   499,   510,    19,    20,    42,    53,   407,
     110,   116,    41,    60,    84,   146,   412,   413,    76,    19,
      83,    19,    79,   124,    20,   110,   556,    19,    19,   440,
     440,   385,    68,    73,    88,   124,   210,   277,   333,   338,
     361,   376,   440,    44,    79,    82,    86,    87,    89,    90,
      91,    96,   130,   135,   386,   441,   459,   440,   440,    49,
      75,    88,   101,   104,   106,   146,   148,   157,   193,   210,
     217,   218,   220,   222,   223,   225,   226,   228,   231,   232,
     234,   247,   248,   252,   254,   255,   257,   262,   266,   267,
     269,   270,   272,   273,   274,   386,   441,   440,   278,   283,
     284,   285,   320,   386,   441,   582,   583,   584,   440,   334,
     335,   386,   441,   440,   440,    65,    89,   104,   128,   129,
     303,   362,   363,   364,   371,   386,   441,   466,   468,   469,
     440,    64,   146,   266,   386,   441,   669,   672,    68,    69,
      70,    72,    73,    75,   386,   424,   427,   441,    70,   112,
     386,   426,   441,    35,    43,   385,   460,   421,     3,     3,
     421,    65,   422,     3,     3,    79,   486,   510,   510,     3,
      35,    43,   385,   463,    19,    20,    43,   511,     3,   145,
     482,     3,     3,   479,   485,   221,    19,    89,   153,   319,
     331,   332,   475,   475,    18,    19,   398,   400,   400,     3,
       3,     3,     3,     3,     3,     3,    15,    19,    28,   382,
     388,   546,   548,   554,    29,   382,   208,    27,   208,    15,
     388,   549,   556,   382,   382,   382,   382,   382,   382,   185,
     186,   187,   188,   536,   556,    15,    16,    17,    19,   382,
     395,   529,   530,   534,   537,   538,   540,   542,   543,   544,
       5,    77,    78,    80,    81,   105,   139,   189,   190,   192,
     193,   194,   195,   196,   197,   198,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   264,   265,   279,   280,   281,
     282,   374,   375,   555,   679,     3,     8,     9,    10,    11,
      12,    22,    23,    24,    25,    26,    27,    28,    29,    32,
      44,    45,    46,    47,    48,    49,    50,    51,    52,   409,
     410,    15,   500,     3,    22,    61,   406,    43,   385,   408,
     460,   382,   395,    20,    56,    57,   381,   142,   131,   434,
      15,    17,    18,   105,   429,   513,    19,   431,   381,   463,
     525,   105,   385,   385,   437,   385,   460,    19,   445,    83,
     395,    34,    35,    36,    37,   395,   397,   458,    43,    92,
      93,    97,   102,   209,   442,   521,    97,   442,    97,    20,
     463,   381,   381,   385,   385,   142,   236,    76,   381,   237,
      20,   397,    97,   275,   146,   251,   127,   397,   381,   395,
     398,   122,   398,    71,   224,    71,   222,   229,   239,   240,
     233,   235,   249,   250,   249,   253,   397,   256,   258,   263,
      79,   233,    88,   268,   233,   271,   269,   397,   220,   381,
     385,   429,   397,    82,   395,   397,   381,   385,   385,    79,
     336,   337,   381,   385,   385,    71,   665,   666,    20,   395,
     385,    93,   369,   370,   660,   395,   395,    71,   218,   372,
     373,   381,   381,   385,   385,   311,   400,    79,   381,   164,
     227,   259,   268,   377,   378,   379,   380,   381,    79,   397,
      71,   397,    74,    76,   381,   381,   381,    71,    20,   404,
     381,   381,    74,    94,    95,   108,   109,   111,   461,   462,
       3,   422,     3,   395,     3,    19,     3,     3,     3,    94,
     136,   464,   465,     3,   511,     3,     3,     3,    79,   115,
     122,   133,   483,     3,    43,    79,    84,    91,    92,   103,
     112,   113,   114,   115,   117,   400,   480,   521,     3,    19,
      79,    84,    85,    92,   119,   158,   475,   475,   475,   621,
      43,   475,    43,   475,     3,     3,    29,   384,   402,   120,
     120,   548,   548,   556,   548,   548,    14,    15,   556,   560,
     561,    26,   208,    27,   549,   549,    29,   556,   556,   556,
     556,   556,    19,    15,   387,   383,   387,    28,   532,   533,
     536,   556,     7,   387,   390,    26,    27,   385,   387,   390,
     556,   556,   556,   556,   556,   556,   556,   556,   556,   556,
     556,   556,   556,   168,   191,   199,   204,   205,   386,   387,
       3,   556,    20,   409,   381,   556,   395,    58,    59,    58,
      59,   395,   453,   454,   381,   166,   167,   168,   169,   170,
     171,   172,   174,   175,   176,   177,   178,   515,   516,   517,
     519,   523,   125,   126,   127,   128,   381,   432,   381,   382,
     522,    19,   119,   386,   429,   447,   450,   451,    19,   519,
     520,    35,   395,   444,   103,   556,   444,   444,   565,    71,
      71,    71,   276,   397,    49,   381,   381,   395,   213,   214,
     397,   261,   397,   398,   381,   381,    30,   399,   395,   122,
     395,    71,   395,    71,   102,   230,   395,   395,   397,    71,
     381,    83,   381,   397,   381,   397,   230,   259,   260,   397,
     445,   397,   381,   381,   397,   397,   397,   381,   122,   397,
      97,   585,    19,   381,   381,   628,   395,   451,   381,   381,
     467,   468,   381,   381,   381,   395,   381,   381,   381,    83,
     118,   163,   470,   397,   445,    20,   398,   398,   227,   670,
     671,   395,   395,   397,   397,   395,   398,   400,   401,   386,
     387,     3,   386,   387,     3,    19,    15,   400,    19,    19,
     520,   401,    19,     3,    20,   612,   612,     3,    19,    82,
     230,   278,   293,   311,   325,   326,   475,   612,   475,   612,
     395,   398,    15,    15,   383,   387,   383,    27,   387,   387,
     387,   383,   387,   383,   387,   556,   556,     7,   387,   387,
     383,    18,   530,   538,    15,    18,   543,   382,   410,   381,
     386,    20,   381,   451,   381,    19,   173,   381,   385,   398,
     395,   383,   516,   518,   523,   400,    27,   449,   387,    98,
     443,   397,    89,   217,   218,   386,   441,   564,   395,   395,
     395,   381,   381,   397,   381,   381,   381,   381,   397,   381,
     381,    19,   122,   381,   395,   381,   395,   381,   395,   381,
     381,   381,   381,   381,   395,   429,   381,   381,   381,   381,
     381,   381,   381,   381,   381,   381,   381,   381,   395,   395,
      89,   145,   231,   284,   308,   310,   316,   318,   322,   323,
     386,   586,   593,   596,   381,    89,   169,   355,   356,   359,
     386,   441,   625,   381,   385,   664,   386,   381,   381,   395,
     105,   107,   105,   107,   386,   381,   381,   399,   398,   321,
     670,   462,   465,     3,     3,   429,   429,    15,   429,   612,
       3,   612,     3,   122,   122,   560,    27,   556,   556,   556,
     556,   556,   387,   383,   532,   556,   533,   535,   556,   387,
     556,   517,    19,    49,    86,   159,   160,   161,   162,   163,
     164,   165,   179,   182,   526,   527,   552,   553,   557,   562,
     381,   383,   120,    20,   401,   448,   450,    76,    99,   100,
     101,   567,   571,   567,   572,   398,   576,   381,   387,   381,
     381,   381,   381,   395,   381,   381,   381,   381,   381,   381,
     605,   611,   397,   286,   287,   322,   286,   397,   587,   311,
     400,   589,   590,   588,   324,   397,   381,   327,   606,   630,
     637,   400,   638,   643,   626,   627,   400,   381,   663,   467,
     381,    20,   403,   403,   403,   403,   399,   395,     3,     3,
      15,    15,   383,   383,   383,   383,   387,   556,   383,   387,
      15,   383,    22,   382,    22,   382,   556,   556,   556,   386,
     562,   555,   679,   381,   556,   558,   559,   518,    15,   401,
     451,   452,   385,   570,    30,   219,   573,   395,   381,   451,
     607,   395,   395,   397,   395,   385,   429,   385,   385,   395,
     395,   385,   452,   385,   642,   385,   398,   644,   649,    20,
     385,   650,   655,   214,   233,   270,   335,   386,   662,   470,
     381,   381,   381,   381,   486,   486,   556,   383,     7,    28,
     535,   386,   556,   561,   556,   552,   381,   180,   385,    22,
      22,    32,   387,   381,   122,   570,   569,    19,    20,   220,
     574,   381,   608,   385,   610,   598,   591,   598,   594,   385,
     636,   641,   640,   645,   651,   140,   141,   291,   455,   395,
     271,   294,   365,   366,   367,   368,   661,   381,   470,   470,
     470,   470,     3,     3,   383,   382,   383,     7,   383,   381,
     383,   381,   679,   385,   528,   562,   545,   556,   556,    92,
     148,   149,   203,   208,   559,    15,   106,   211,   212,   215,
     216,   386,   568,   398,   217,   575,   606,   609,   386,   400,
     599,   600,   145,   286,   309,   386,   592,   386,   142,   288,
     289,   290,   292,   303,   386,   466,   595,   635,   634,   348,
     349,   352,   353,   354,   386,   639,   648,   654,   395,   395,
     395,   214,   397,   532,   535,   383,   526,   181,     6,    15,
      16,    17,   382,   386,   529,   531,   534,   537,   539,   541,
     381,   381,   382,   382,   382,   382,   381,   381,   397,   213,
     214,   214,   395,   396,   395,   381,   397,    64,   142,   153,
     210,   213,   214,   270,   273,   284,   286,   288,   289,   290,
     291,   292,   293,   299,   303,   304,   307,   320,   328,   386,
     466,   597,   309,   317,   601,   397,   395,   397,   381,   395,
     395,   395,   235,   114,   395,    93,   302,   305,   381,   120,
     169,   211,   231,   311,   340,   341,   344,   345,   347,   355,
     356,   386,   631,   351,   351,   397,   397,   397,   381,   351,
     357,   386,   646,   351,   358,   386,   652,   312,   387,   383,
     381,   386,   528,   526,   556,     7,   384,   387,   556,   556,
     556,   556,   215,   215,   215,    38,    39,    40,   311,   395,
     385,   397,   313,   291,   330,   455,   271,   397,   397,   395,
     395,   395,   235,   395,   114,   395,   294,   295,   296,   297,
     298,   299,   300,   301,   329,    93,   302,   305,   296,   395,
     321,   294,   381,   395,   381,   395,   395,   339,   643,   235,
     339,   351,   343,   397,   342,    71,   346,   229,   220,   632,
     220,   633,   381,   395,   395,   350,   395,   656,   644,   647,
     381,   656,   650,   653,   381,   532,   383,   382,   531,   526,
     539,   383,   383,   383,   383,   396,   396,   396,   397,   602,
     314,   315,   395,   395,   395,   214,   397,   395,   395,   397,
     397,   395,   397,   215,   395,   215,   395,   395,   397,   395,
     395,    97,   397,   649,   397,   655,   360,   657,   657,   395,
     383,   556,   381,   381,   381,   381,    18,   386,   604,   312,
     395,   395,   657,   395,   397,   306,   603,   381
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 720 "cf-parse.y"
    { return 0; }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 721 "cf-parse.y"
    { return 0; }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 734 "cf-parse.y"
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[(4) - (5)].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_CONSTANT | val->type, val);
   }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 744 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 745 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[(1) - (1)].s)).i; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 752 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000000; }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 753 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000; }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 754 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1; }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 762 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 763 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 764 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 765 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 766 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 767 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 774 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[(1) - (1)].s)).px.ip;
   }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 781 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 782 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 786 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 794 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 798 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 802 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 809 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 817 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 818 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 824 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 833 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 834 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 838 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 843 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 844 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 848 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 849 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 853 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 854 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 858 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 859 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 860 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 861 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 862 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 863 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 864 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 865 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 866 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 872 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 873 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 882 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 883 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 884 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 885 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 888 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 889 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 890 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 891 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 892 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){NULL, NULL, 0}; }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 893 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 905 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 908 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 915 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 918 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 921 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 924 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 927 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 932 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 933 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 934 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 942 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 947 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 948 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 952 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 959 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 960 "cf-parse.y"
    { THIS_KRT->graceful_restart = (yyvsp[(3) - (3)].i); }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 966 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 971 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 975 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 989 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i);
   }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 1003 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 1004 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 1008 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 1010 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 1029 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 1030 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 1031 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 1032 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 1037 "cf-parse.y"
    { new_config->gr_wait = (yyvsp[(4) - (5)].i); }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 1043 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 1044 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 1048 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 1056 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 1062 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 1076 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 1077 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 1081 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 1087 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 1091 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 1103 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 1107 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 1108 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 1109 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 1110 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 1111 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 1112 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 1113 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1114 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1115 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1116 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 1117 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 1118 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 1122 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1124 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1125 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1129 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 1130 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1131 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1132 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 1133 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1137 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1143 "cf-parse.y"
    { (yyval.g) = NULL; }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1147 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1155 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1156 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 1164 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 1172 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1173 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 1174 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 1178 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1179 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 1193 "cf-parse.y"
    { iface_patt_check(); }
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 1195 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 1207 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i) & 0xfc;        if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("TX class must be in range 0-255"); }
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1208 "cf-parse.y"
    { (yyval.i) = ((yyvsp[(2) - (2)].i) & 0x3f) << 2; if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1214 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1227 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 158:
/* Line 1792 of yacc.c  */
#line 1241 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 159:
/* Line 1792 of yacc.c  */
#line 1242 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 1243 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 1248 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 1252 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 1253 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 1254 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 1255 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 1256 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 168:
/* Line 1792 of yacc.c  */
#line 1257 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 169:
/* Line 1792 of yacc.c  */
#line 1263 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 1264 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 1265 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 1270 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 1274 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 1275 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 1296 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 1314 "cf-parse.y"
    { }
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 1315 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 185:
/* Line 1792 of yacc.c  */
#line 1316 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 1317 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 1318 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1319 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 1328 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 1331 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 1334 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 1337 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 1341 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 195:
/* Line 1792 of yacc.c  */
#line 1345 "cf-parse.y"
    { if_show(); }
    break;

  case 196:
/* Line 1792 of yacc.c  */
#line 1348 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 197:
/* Line 1792 of yacc.c  */
#line 1352 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 198:
/* Line 1792 of yacc.c  */
#line 1355 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 1360 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 1366 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 1373 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1378 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1383 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 1388 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 1392 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 1396 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 1400 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 1410 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 1418 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 1422 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1429 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1430 "cf-parse.y"
    { (yyval.i) = 2; }
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1436 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 1439 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1446 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1453 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1457 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1465 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1466 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 1467 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 1473 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 1476 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 1479 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 1480 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 1481 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 1482 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 1483 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 1484 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 1485 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 1490 "cf-parse.y"
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 1495 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 1504 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 1511 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 1518 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 1526 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 1528 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 1530 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 1532 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 1534 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1536 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1538 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1541 "cf-parse.y"
    { cmd_eval((yyvsp[(2) - (3)].x)); }
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 1544 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 1550 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 1551 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1552 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1556 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1557 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1564 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1566 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1568 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1570 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1572 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 1574 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 1578 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1582 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 1585 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 258:
/* Line 1792 of yacc.c  */
#line 1588 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 1589 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1590 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1594 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 1595 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 1596 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 1604 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 1605 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 1614 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 1618 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 1619 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 1620 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 1621 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 1622 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 1623 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 273:
/* Line 1792 of yacc.c  */
#line 1624 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 1625 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 1626 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 1627 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 1628 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 1629 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 1630 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 1651 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 1662 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 1663 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 1670 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 1671 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 1678 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 1687 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 1695 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 1719 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 1720 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 1724 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 292:
/* Line 1792 of yacc.c  */
#line 1737 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 1740 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   }
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 1753 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 1754 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 1757 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 1758 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 1762 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 1765 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 1774 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 1787 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 302:
/* Line 1792 of yacc.c  */
#line 1788 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 303:
/* Line 1792 of yacc.c  */
#line 1789 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 304:
/* Line 1792 of yacc.c  */
#line 1790 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 305:
/* Line 1792 of yacc.c  */
#line 1794 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 1795 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 1796 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 308:
/* Line 1792 of yacc.c  */
#line 1797 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 1798 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 1802 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(1) - (1)].x)); check_u16((yyval.i)); }
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 1805 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (1)].i), (yyvsp[(1) - (1)].i)); }
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 1806 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (3)].i), (yyvsp[(3) - (3)].i)); }
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 1807 "cf-parse.y"
    { (yyval.i32) = 0xFFFF; }
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 1811 "cf-parse.y"
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[(2) - (5)].i32)), pair_b((yyvsp[(2) - (5)].i32)), pair_a((yyvsp[(4) - (5)].i32)), pair_b((yyvsp[(4) - (5)].i32)));
   }
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 1814 "cf-parse.y"
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[(2) - (11)].i32)) != pair_b((yyvsp[(2) - (11)].i32))) || (pair_a((yyvsp[(4) - (11)].i32)) != pair_b((yyvsp[(4) - (11)].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[(2) - (11)].i32)), (yyvsp[(8) - (11)].i), pair_b((yyvsp[(4) - (11)].i32)), (yyvsp[(10) - (11)].i)); 
   }
    break;

  case 316:
/* Line 1792 of yacc.c  */
#line 1823 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 317:
/* Line 1792 of yacc.c  */
#line 1826 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 1827 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 1828 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 320:
/* Line 1792 of yacc.c  */
#line 1829 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 321:
/* Line 1792 of yacc.c  */
#line 1833 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 1834 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 1835 "cf-parse.y"
    {  (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 326:
/* Line 1792 of yacc.c  */
#line 1841 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 1842 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 1848 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 331:
/* Line 1792 of yacc.c  */
#line 1849 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 1854 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 335:
/* Line 1792 of yacc.c  */
#line 1859 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 336:
/* Line 1792 of yacc.c  */
#line 1863 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 1870 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 338:
/* Line 1792 of yacc.c  */
#line 1871 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 339:
/* Line 1792 of yacc.c  */
#line 1872 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 340:
/* Line 1792 of yacc.c  */
#line 1873 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 341:
/* Line 1792 of yacc.c  */
#line 1880 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 1881 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 1884 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 1885 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 1892 "cf-parse.y"
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 346:
/* Line 1792 of yacc.c  */
#line 1904 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 347:
/* Line 1792 of yacc.c  */
#line 1905 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 348:
/* Line 1792 of yacc.c  */
#line 1909 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 349:
/* Line 1792 of yacc.c  */
#line 1910 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 350:
/* Line 1792 of yacc.c  */
#line 1914 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 351:
/* Line 1792 of yacc.c  */
#line 1915 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 352:
/* Line 1792 of yacc.c  */
#line 1916 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 1917 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 1918 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 1922 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 356:
/* Line 1792 of yacc.c  */
#line 1923 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 357:
/* Line 1792 of yacc.c  */
#line 1924 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 358:
/* Line 1792 of yacc.c  */
#line 1928 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 1929 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 360:
/* Line 1792 of yacc.c  */
#line 1930 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 1931 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 1932 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 363:
/* Line 1792 of yacc.c  */
#line 1933 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 1934 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 1935 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 366:
/* Line 1792 of yacc.c  */
#line 1936 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 367:
/* Line 1792 of yacc.c  */
#line 1937 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 368:
/* Line 1792 of yacc.c  */
#line 1938 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 369:
/* Line 1792 of yacc.c  */
#line 1942 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 1943 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 372:
/* Line 1792 of yacc.c  */
#line 1957 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 373:
/* Line 1792 of yacc.c  */
#line 1980 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[(1) - (1)].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 374:
/* Line 1792 of yacc.c  */
#line 1994 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
    break;

  case 375:
/* Line 1792 of yacc.c  */
#line 1995 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
    break;

  case 376:
/* Line 1792 of yacc.c  */
#line 1996 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
    break;

  case 377:
/* Line 1792 of yacc.c  */
#line 1997 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
    break;

  case 378:
/* Line 1792 of yacc.c  */
#line 1998 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
    break;

  case 379:
/* Line 1792 of yacc.c  */
#line 1999 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 2000 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
    break;

  case 381:
/* Line 1792 of yacc.c  */
#line 2001 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
    break;

  case 382:
/* Line 1792 of yacc.c  */
#line 2002 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 2003 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
    break;

  case 384:
/* Line 1792 of yacc.c  */
#line 2007 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 2008 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 2009 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 387:
/* Line 1792 of yacc.c  */
#line 2010 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 2011 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 389:
/* Line 1792 of yacc.c  */
#line 2012 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 2013 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 2014 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 392:
/* Line 1792 of yacc.c  */
#line 2015 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 393:
/* Line 1792 of yacc.c  */
#line 2016 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 394:
/* Line 1792 of yacc.c  */
#line 2017 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 395:
/* Line 1792 of yacc.c  */
#line 2018 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 396:
/* Line 1792 of yacc.c  */
#line 2019 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 397:
/* Line 1792 of yacc.c  */
#line 2020 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 398:
/* Line 1792 of yacc.c  */
#line 2021 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 399:
/* Line 1792 of yacc.c  */
#line 2022 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 2024 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 2025 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 402:
/* Line 1792 of yacc.c  */
#line 2026 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 403:
/* Line 1792 of yacc.c  */
#line 2028 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 404:
/* Line 1792 of yacc.c  */
#line 2030 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 405:
/* Line 1792 of yacc.c  */
#line 2032 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 406:
/* Line 1792 of yacc.c  */
#line 2034 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 407:
/* Line 1792 of yacc.c  */
#line 2035 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 408:
/* Line 1792 of yacc.c  */
#line 2036 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 409:
/* Line 1792 of yacc.c  */
#line 2037 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 2038 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 2048 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 2049 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 2050 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 2051 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 2052 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 2053 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 2054 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 2056 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2057 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 2062 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2085 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2086 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 423:
/* Line 1792 of yacc.c  */
#line 2087 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 2088 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 2089 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 2090 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 2094 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 2097 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 2098 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 2099 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 2107 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 2114 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 2123 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 2124 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 2128 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 2134 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 2144 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 2153 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 2159 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 2164 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 2171 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 442:
/* Line 1792 of yacc.c  */
#line 2176 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 443:
/* Line 1792 of yacc.c  */
#line 2182 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 2183 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 2184 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 2192 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); }
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 2193 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 2194 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 2195 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 2196 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 2203 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_bfd, sizeof(struct bfd_config), (yyvsp[(1) - (2)].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
    break;

  case 459:
/* Line 1792 of yacc.c  */
#line 2230 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;
}
    break;

  case 460:
/* Line 1792 of yacc.c  */
#line 2241 "cf-parse.y"
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[(2) - (2)].i32); }
    break;

  case 461:
/* Line 1792 of yacc.c  */
#line 2242 "cf-parse.y"
    { BFD_IFACE->min_rx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 462:
/* Line 1792 of yacc.c  */
#line 2243 "cf-parse.y"
    { BFD_IFACE->min_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 463:
/* Line 1792 of yacc.c  */
#line 2244 "cf-parse.y"
    { BFD_IFACE->idle_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 464:
/* Line 1792 of yacc.c  */
#line 2245 "cf-parse.y"
    { BFD_IFACE->multiplier = (yyvsp[(2) - (2)].i); }
    break;

  case 465:
/* Line 1792 of yacc.c  */
#line 2246 "cf-parse.y"
    { BFD_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 470:
/* Line 1792 of yacc.c  */
#line 2260 "cf-parse.y"
    { add_tail(&BFD_CFG->patt_list, NODE this_ipatt); }
    break;

  case 471:
/* Line 1792 of yacc.c  */
#line 2263 "cf-parse.y"
    { BFD_CFG->multihop = BFD_IFACE; }
    break;

  case 472:
/* Line 1792 of yacc.c  */
#line 2267 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 473:
/* Line 1792 of yacc.c  */
#line 2268 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 474:
/* Line 1792 of yacc.c  */
#line 2269 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].t)); }
    break;

  case 475:
/* Line 1792 of yacc.c  */
#line 2273 "cf-parse.y"
    { (yyval.a) = IPA_NONE; }
    break;

  case 476:
/* Line 1792 of yacc.c  */
#line 2274 "cf-parse.y"
    { (yyval.a) = (yyvsp[(2) - (2)].a); }
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 2278 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 2279 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 479:
/* Line 1792 of yacc.c  */
#line 2283 "cf-parse.y"
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[(1) - (4)].a);
  BFD_NEIGHBOR->local = (yyvsp[(3) - (4)].a);
  BFD_NEIGHBOR->iface = (yyvsp[(2) - (4)].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[(4) - (4)].i);

  if ((yyvsp[(4) - (4)].i) && (yyvsp[(2) - (4)].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[(4) - (4)].i) && ipa_zero((yyvsp[(3) - (4)].a)))
    cf_error("Multihop neighbor requires specified local address");
}
    break;

  case 480:
/* Line 1792 of yacc.c  */
#line 2302 "cf-parse.y"
    { bfd_show_sessions(proto_get_named((yyvsp[(4) - (5)].s), &proto_bfd)); }
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 2307 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[(1) - (2)].i));
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
 }
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 2333 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 2334 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 2335 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[(3) - (7)].a)) != !(yyvsp[(4) - (7)].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[(3) - (7)].a);
     BGP_CFG->iface = (yyvsp[(4) - (7)].iface);
     BGP_CFG->remote_as = (yyvsp[(6) - (7)].i);
   }
    break;

  case 487:
/* Line 1792 of yacc.c  */
#line 2345 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 488:
/* Line 1792 of yacc.c  */
#line 2346 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 489:
/* Line 1792 of yacc.c  */
#line 2347 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 490:
/* Line 1792 of yacc.c  */
#line 2348 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 2349 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 492:
/* Line 1792 of yacc.c  */
#line 2350 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 493:
/* Line 1792 of yacc.c  */
#line 2351 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 494:
/* Line 1792 of yacc.c  */
#line 2352 "cf-parse.y"
    { BGP_CFG->multihop = 0; }
    break;

  case 495:
/* Line 1792 of yacc.c  */
#line 2353 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 496:
/* Line 1792 of yacc.c  */
#line 2354 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 497:
/* Line 1792 of yacc.c  */
#line 2355 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
    break;

  case 498:
/* Line 1792 of yacc.c  */
#line 2356 "cf-parse.y"
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
    break;

  case 499:
/* Line 1792 of yacc.c  */
#line 2357 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 500:
/* Line 1792 of yacc.c  */
#line 2358 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 2359 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 2360 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 2361 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 504:
/* Line 1792 of yacc.c  */
#line 2362 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 505:
/* Line 1792 of yacc.c  */
#line 2363 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 506:
/* Line 1792 of yacc.c  */
#line 2364 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 507:
/* Line 1792 of yacc.c  */
#line 2365 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 508:
/* Line 1792 of yacc.c  */
#line 2366 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 509:
/* Line 1792 of yacc.c  */
#line 2367 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 510:
/* Line 1792 of yacc.c  */
#line 2368 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 511:
/* Line 1792 of yacc.c  */
#line 2369 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 512:
/* Line 1792 of yacc.c  */
#line 2370 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 513:
/* Line 1792 of yacc.c  */
#line 2371 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 514:
/* Line 1792 of yacc.c  */
#line 2372 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 515:
/* Line 1792 of yacc.c  */
#line 2373 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 516:
/* Line 1792 of yacc.c  */
#line 2374 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 517:
/* Line 1792 of yacc.c  */
#line 2375 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 2376 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 519:
/* Line 1792 of yacc.c  */
#line 2377 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 520:
/* Line 1792 of yacc.c  */
#line 2378 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 2379 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
   }
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 2384 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 2385 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 2386 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 2387 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_RX; }
    break;

  case 526:
/* Line 1792 of yacc.c  */
#line 2388 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_TX; }
    break;

  case 527:
/* Line 1792 of yacc.c  */
#line 2389 "cf-parse.y"
    { BGP_CFG->add_path = (yyvsp[(4) - (5)].i) ? ADD_PATH_FULL : 0; }
    break;

  case 528:
/* Line 1792 of yacc.c  */
#line 2390 "cf-parse.y"
    { BGP_CFG->allow_local_as = -1; }
    break;

  case 529:
/* Line 1792 of yacc.c  */
#line 2391 "cf-parse.y"
    { BGP_CFG->allow_local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 530:
/* Line 1792 of yacc.c  */
#line 2392 "cf-parse.y"
    { BGP_CFG->gr_mode = (yyvsp[(4) - (5)].i); }
    break;

  case 531:
/* Line 1792 of yacc.c  */
#line 2393 "cf-parse.y"
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
    break;

  case 532:
/* Line 1792 of yacc.c  */
#line 2394 "cf-parse.y"
    { BGP_CFG->gr_time = (yyvsp[(5) - (6)].i); }
    break;

  case 533:
/* Line 1792 of yacc.c  */
#line 2395 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 534:
/* Line 1792 of yacc.c  */
#line 2396 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 2397 "cf-parse.y"
    { BGP_CFG->bfd = (yyvsp[(3) - (4)].i); cf_check_bfd((yyvsp[(3) - (4)].i)); }
    break;

  case 536:
/* Line 1792 of yacc.c  */
#line 2408 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
    break;

  case 540:
/* Line 1792 of yacc.c  */
#line 2424 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 541:
/* Line 1792 of yacc.c  */
#line 2425 "cf-parse.y"
    { OSPF_CFG->stub_router = (yyvsp[(3) - (3)].i); }
    break;

  case 542:
/* Line 1792 of yacc.c  */
#line 2426 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 543:
/* Line 1792 of yacc.c  */
#line 2427 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 544:
/* Line 1792 of yacc.c  */
#line 2428 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 546:
/* Line 1792 of yacc.c  */
#line 2432 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 547:
/* Line 1792 of yacc.c  */
#line 2447 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 550:
/* Line 1792 of yacc.c  */
#line 2456 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 551:
/* Line 1792 of yacc.c  */
#line 2457 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 552:
/* Line 1792 of yacc.c  */
#line 2458 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 553:
/* Line 1792 of yacc.c  */
#line 2459 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 554:
/* Line 1792 of yacc.c  */
#line 2460 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 555:
/* Line 1792 of yacc.c  */
#line 2461 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT_EBIT; check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 556:
/* Line 1792 of yacc.c  */
#line 2462 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i);  check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 557:
/* Line 1792 of yacc.c  */
#line 2463 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 558:
/* Line 1792 of yacc.c  */
#line 2464 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 559:
/* Line 1792 of yacc.c  */
#line 2465 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 561:
/* Line 1792 of yacc.c  */
#line 2466 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 568:
/* Line 1792 of yacc.c  */
#line 2478 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 571:
/* Line 1792 of yacc.c  */
#line 2492 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 572:
/* Line 1792 of yacc.c  */
#line 2493 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 573:
/* Line 1792 of yacc.c  */
#line 2494 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 574:
/* Line 1792 of yacc.c  */
#line 2498 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 575:
/* Line 1792 of yacc.c  */
#line 2499 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 579:
/* Line 1792 of yacc.c  */
#line 2508 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 580:
/* Line 1792 of yacc.c  */
#line 2509 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 581:
/* Line 1792 of yacc.c  */
#line 2510 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 582:
/* Line 1792 of yacc.c  */
#line 2511 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 583:
/* Line 1792 of yacc.c  */
#line 2512 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 584:
/* Line 1792 of yacc.c  */
#line 2513 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 585:
/* Line 1792 of yacc.c  */
#line 2514 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 586:
/* Line 1792 of yacc.c  */
#line 2515 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 587:
/* Line 1792 of yacc.c  */
#line 2516 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 589:
/* Line 1792 of yacc.c  */
#line 2521 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 590:
/* Line 1792 of yacc.c  */
#line 2542 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 591:
/* Line 1792 of yacc.c  */
#line 2543 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 592:
/* Line 1792 of yacc.c  */
#line 2544 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 593:
/* Line 1792 of yacc.c  */
#line 2545 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 594:
/* Line 1792 of yacc.c  */
#line 2546 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 595:
/* Line 1792 of yacc.c  */
#line 2547 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 596:
/* Line 1792 of yacc.c  */
#line 2548 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 597:
/* Line 1792 of yacc.c  */
#line 2549 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 598:
/* Line 1792 of yacc.c  */
#line 2550 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 599:
/* Line 1792 of yacc.c  */
#line 2551 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 600:
/* Line 1792 of yacc.c  */
#line 2552 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 601:
/* Line 1792 of yacc.c  */
#line 2553 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 602:
/* Line 1792 of yacc.c  */
#line 2554 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 603:
/* Line 1792 of yacc.c  */
#line 2555 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 604:
/* Line 1792 of yacc.c  */
#line 2556 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 605:
/* Line 1792 of yacc.c  */
#line 2557 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 606:
/* Line 1792 of yacc.c  */
#line 2558 "cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real netmask option requires OSPFv2"); }
    break;

  case 607:
/* Line 1792 of yacc.c  */
#line 2559 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 608:
/* Line 1792 of yacc.c  */
#line 2560 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 609:
/* Line 1792 of yacc.c  */
#line 2561 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 610:
/* Line 1792 of yacc.c  */
#line 2562 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 611:
/* Line 1792 of yacc.c  */
#line 2563 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 612:
/* Line 1792 of yacc.c  */
#line 2564 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 614:
/* Line 1792 of yacc.c  */
#line 2566 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 615:
/* Line 1792 of yacc.c  */
#line 2567 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 616:
/* Line 1792 of yacc.c  */
#line 2568 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 617:
/* Line 1792 of yacc.c  */
#line 2569 "cf-parse.y"
    { OSPF_PATT->rx_buffer = 0; }
    break;

  case 618:
/* Line 1792 of yacc.c  */
#line 2570 "cf-parse.y"
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
    break;

  case 619:
/* Line 1792 of yacc.c  */
#line 2571 "cf-parse.y"
    { OSPF_PATT->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 620:
/* Line 1792 of yacc.c  */
#line 2572 "cf-parse.y"
    { OSPF_PATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 621:
/* Line 1792 of yacc.c  */
#line 2573 "cf-parse.y"
    { OSPF_PATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 622:
/* Line 1792 of yacc.c  */
#line 2574 "cf-parse.y"
    { OSPF_PATT->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 623:
/* Line 1792 of yacc.c  */
#line 2575 "cf-parse.y"
    { OSPF_PATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 624:
/* Line 1792 of yacc.c  */
#line 2576 "cf-parse.y"
    { OSPF_PATT->ttl_security = 2; }
    break;

  case 625:
/* Line 1792 of yacc.c  */
#line 2577 "cf-parse.y"
    { OSPF_PATT->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 626:
/* Line 1792 of yacc.c  */
#line 2578 "cf-parse.y"
    { OSPF_PATT->bsd_secondary = (yyvsp[(2) - (2)].i); }
    break;

  case 631:
/* Line 1792 of yacc.c  */
#line 2590 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 633:
/* Line 1792 of yacc.c  */
#line 2600 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 634:
/* Line 1792 of yacc.c  */
#line 2601 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 637:
/* Line 1792 of yacc.c  */
#line 2610 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 638:
/* Line 1792 of yacc.c  */
#line 2611 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 639:
/* Line 1792 of yacc.c  */
#line 2615 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 }
    break;

  case 640:
/* Line 1792 of yacc.c  */
#line 2624 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
    break;

  case 642:
/* Line 1792 of yacc.c  */
#line 2649 "cf-parse.y"
    { set_instance_id((yyvsp[(2) - (2)].i)); }
    break;

  case 643:
/* Line 1792 of yacc.c  */
#line 2653 "cf-parse.y"
    { if (OSPF_VERSION == 3) iface_patt_check(); }
    break;

  case 649:
/* Line 1792 of yacc.c  */
#line 2667 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 651:
/* Line 1792 of yacc.c  */
#line 2672 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 652:
/* Line 1792 of yacc.c  */
#line 2678 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 653:
/* Line 1792 of yacc.c  */
#line 2681 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 654:
/* Line 1792 of yacc.c  */
#line 2684 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 655:
/* Line 1792 of yacc.c  */
#line 2689 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 656:
/* Line 1792 of yacc.c  */
#line 2692 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 657:
/* Line 1792 of yacc.c  */
#line 2697 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 658:
/* Line 1792 of yacc.c  */
#line 2700 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 659:
/* Line 1792 of yacc.c  */
#line 2704 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 660:
/* Line 1792 of yacc.c  */
#line 2707 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 661:
/* Line 1792 of yacc.c  */
#line 2710 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 662:
/* Line 1792 of yacc.c  */
#line 2711 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); }
    break;

  case 663:
/* Line 1792 of yacc.c  */
#line 2712 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 664:
/* Line 1792 of yacc.c  */
#line 2713 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 665:
/* Line 1792 of yacc.c  */
#line 2714 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 666:
/* Line 1792 of yacc.c  */
#line 2715 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 667:
/* Line 1792 of yacc.c  */
#line 2716 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 668:
/* Line 1792 of yacc.c  */
#line 2717 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 669:
/* Line 1792 of yacc.c  */
#line 2723 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 672:
/* Line 1792 of yacc.c  */
#line 2732 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 673:
/* Line 1792 of yacc.c  */
#line 2737 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 674:
/* Line 1792 of yacc.c  */
#line 2738 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 675:
/* Line 1792 of yacc.c  */
#line 2745 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_radv, sizeof(struct radv_config), (yyvsp[(1) - (2)].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
    break;

  case 678:
/* Line 1792 of yacc.c  */
#line 2756 "cf-parse.y"
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
    break;

  case 679:
/* Line 1792 of yacc.c  */
#line 2757 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 680:
/* Line 1792 of yacc.c  */
#line 2757 "cf-parse.y"
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
    break;

  case 681:
/* Line 1792 of yacc.c  */
#line 2758 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 682:
/* Line 1792 of yacc.c  */
#line 2758 "cf-parse.y"
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
    break;

  case 683:
/* Line 1792 of yacc.c  */
#line 2759 "cf-parse.y"
    {
     RADV_CFG->trigger_prefix = (yyvsp[(2) - (2)].px).addr;
     RADV_CFG->trigger_pxlen = (yyvsp[(2) - (2)].px).len;
     RADV_CFG->trigger_valid = 1;
   }
    break;

  case 687:
/* Line 1792 of yacc.c  */
#line 2776 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
}
    break;

  case 688:
/* Line 1792 of yacc.c  */
#line 2793 "cf-parse.y"
    { RADV_IFACE->min_ra_int = (yyvsp[(4) - (4)].i); if ((yyvsp[(4) - (4)].i) < 3) cf_error("Min RA interval must be at least 3"); }
    break;

  case 689:
/* Line 1792 of yacc.c  */
#line 2794 "cf-parse.y"
    { RADV_IFACE->max_ra_int = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 4) || ((yyvsp[(4) - (4)].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
    break;

  case 690:
/* Line 1792 of yacc.c  */
#line 2795 "cf-parse.y"
    { RADV_IFACE->min_delay = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) <= 0) cf_error("Min delay must be positive"); }
    break;

  case 691:
/* Line 1792 of yacc.c  */
#line 2796 "cf-parse.y"
    { RADV_IFACE->managed = (yyvsp[(2) - (2)].i); }
    break;

  case 692:
/* Line 1792 of yacc.c  */
#line 2797 "cf-parse.y"
    { RADV_IFACE->other_config = (yyvsp[(3) - (3)].i); }
    break;

  case 693:
/* Line 1792 of yacc.c  */
#line 2798 "cf-parse.y"
    { RADV_IFACE->link_mtu = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Link MTU must be 0 or positive"); }
    break;

  case 694:
/* Line 1792 of yacc.c  */
#line 2799 "cf-parse.y"
    { RADV_IFACE->reachable_time = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
    break;

  case 695:
/* Line 1792 of yacc.c  */
#line 2800 "cf-parse.y"
    { RADV_IFACE->retrans_timer = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
    break;

  case 696:
/* Line 1792 of yacc.c  */
#line 2801 "cf-parse.y"
    { RADV_IFACE->current_hop_limit = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 0) || ((yyvsp[(4) - (4)].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
    break;

  case 697:
/* Line 1792 of yacc.c  */
#line 2802 "cf-parse.y"
    {
     RADV_IFACE->default_lifetime = (yyvsp[(3) - (4)].i);
     if (((yyvsp[(3) - (4)].i) < 0) || ((yyvsp[(3) - (4)].i) > 9000))  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 698:
/* Line 1792 of yacc.c  */
#line 2807 "cf-parse.y"
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
    break;

  case 699:
/* Line 1792 of yacc.c  */
#line 2808 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 700:
/* Line 1792 of yacc.c  */
#line 2808 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
    break;

  case 701:
/* Line 1792 of yacc.c  */
#line 2809 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 702:
/* Line 1792 of yacc.c  */
#line 2809 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
    break;

  case 703:
/* Line 1792 of yacc.c  */
#line 2810 "cf-parse.y"
    { RADV_IFACE->rdnss_local = (yyvsp[(3) - (3)].i); }
    break;

  case 704:
/* Line 1792 of yacc.c  */
#line 2811 "cf-parse.y"
    { RADV_IFACE->dnssl_local = (yyvsp[(3) - (3)].i); }
    break;

  case 705:
/* Line 1792 of yacc.c  */
#line 2815 "cf-parse.y"
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");
}
    break;

  case 711:
/* Line 1792 of yacc.c  */
#line 2848 "cf-parse.y"
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[(1) - (1)].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[(1) - (1)].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
    break;

  case 712:
/* Line 1792 of yacc.c  */
#line 2860 "cf-parse.y"
    { RADV_PREFIX->skip = (yyvsp[(2) - (2)].i); }
    break;

  case 713:
/* Line 1792 of yacc.c  */
#line 2861 "cf-parse.y"
    { RADV_PREFIX->onlink = (yyvsp[(2) - (2)].i); }
    break;

  case 714:
/* Line 1792 of yacc.c  */
#line 2862 "cf-parse.y"
    { RADV_PREFIX->autonomous = (yyvsp[(2) - (2)].i); }
    break;

  case 715:
/* Line 1792 of yacc.c  */
#line 2863 "cf-parse.y"
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) < 0) cf_error("Valid lifetime must be 0 or positive");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 716:
/* Line 1792 of yacc.c  */
#line 2868 "cf-parse.y"
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) < 0) cf_error("Preferred lifetime must be 0 or positive");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 717:
/* Line 1792 of yacc.c  */
#line 2876 "cf-parse.y"
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
    break;

  case 723:
/* Line 1792 of yacc.c  */
#line 2900 "cf-parse.y"
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[(1) - (1)].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 724:
/* Line 1792 of yacc.c  */
#line 2909 "cf-parse.y"
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 727:
/* Line 1792 of yacc.c  */
#line 2916 "cf-parse.y"
    { RADV_RDNSS->lifetime = (yyvsp[(2) - (2)].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
    break;

  case 728:
/* Line 1792 of yacc.c  */
#line 2920 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
    break;

  case 733:
/* Line 1792 of yacc.c  */
#line 2944 "cf-parse.y"
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[(1) - (1)].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
    break;

  case 734:
/* Line 1792 of yacc.c  */
#line 2956 "cf-parse.y"
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 737:
/* Line 1792 of yacc.c  */
#line 2963 "cf-parse.y"
    { RADV_DNSSL->lifetime = (yyvsp[(2) - (2)].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
    break;

  case 738:
/* Line 1792 of yacc.c  */
#line 2967 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
    break;

  case 743:
/* Line 1792 of yacc.c  */
#line 2991 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (1)].i); radv_mult_val = 0; }
    break;

  case 744:
/* Line 1792 of yacc.c  */
#line 2992 "cf-parse.y"
    { (yyval.i) = 0; radv_mult_val = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) < 1) || ((yyvsp[(2) - (2)].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
    break;

  case 745:
/* Line 1792 of yacc.c  */
#line 2996 "cf-parse.y"
    { (yyval.i) = -1; }
    break;

  case 746:
/* Line 1792 of yacc.c  */
#line 2997 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 747:
/* Line 1792 of yacc.c  */
#line 3003 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[(1) - (2)].i));
     rip_init_config(RIP_CFG);
   }
    break;

  case 750:
/* Line 1792 of yacc.c  */
#line 3012 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); }
    break;

  case 751:
/* Line 1792 of yacc.c  */
#line 3013 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); }
    break;

  case 752:
/* Line 1792 of yacc.c  */
#line 3014 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); }
    break;

  case 753:
/* Line 1792 of yacc.c  */
#line 3015 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); }
    break;

  case 754:
/* Line 1792 of yacc.c  */
#line 3016 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); }
    break;

  case 755:
/* Line 1792 of yacc.c  */
#line 3017 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); }
    break;

  case 757:
/* Line 1792 of yacc.c  */
#line 3019 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; }
    break;

  case 758:
/* Line 1792 of yacc.c  */
#line 3020 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; }
    break;

  case 759:
/* Line 1792 of yacc.c  */
#line 3021 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; }
    break;

  case 761:
/* Line 1792 of yacc.c  */
#line 3026 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; }
    break;

  case 762:
/* Line 1792 of yacc.c  */
#line 3027 "cf-parse.y"
    { (yyval.i)=AT_MD5; }
    break;

  case 763:
/* Line 1792 of yacc.c  */
#line 3028 "cf-parse.y"
    { (yyval.i)=AT_NONE; }
    break;

  case 764:
/* Line 1792 of yacc.c  */
#line 3033 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; }
    break;

  case 765:
/* Line 1792 of yacc.c  */
#line 3034 "cf-parse.y"
    { (yyval.i)=0; }
    break;

  case 766:
/* Line 1792 of yacc.c  */
#line 3035 "cf-parse.y"
    { (yyval.i)=IM_QUIET; }
    break;

  case 767:
/* Line 1792 of yacc.c  */
#line 3036 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; }
    break;

  case 768:
/* Line 1792 of yacc.c  */
#line 3037 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
    break;

  case 770:
/* Line 1792 of yacc.c  */
#line 3041 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); }
    break;

  case 771:
/* Line 1792 of yacc.c  */
#line 3042 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); }
    break;

  case 772:
/* Line 1792 of yacc.c  */
#line 3043 "cf-parse.y"
    { RIP_IPATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 773:
/* Line 1792 of yacc.c  */
#line 3044 "cf-parse.y"
    { RIP_IPATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 774:
/* Line 1792 of yacc.c  */
#line 3045 "cf-parse.y"
    { RIP_IPATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 775:
/* Line 1792 of yacc.c  */
#line 3046 "cf-parse.y"
    { RIP_IPATT->ttl_security = 2; }
    break;

  case 780:
/* Line 1792 of yacc.c  */
#line 3060 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
     RIP_IPATT->tx_tos = IP_PREC_INTERNET_CONTROL;
     RIP_IPATT->tx_priority = sk_priority_control;
     RIP_IPATT->ttl_security = RIP_DEFAULT_TTL_SECURITY;
   }
    break;

  case 782:
/* Line 1792 of yacc.c  */
#line 3079 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 785:
/* Line 1792 of yacc.c  */
#line 3088 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 786:
/* Line 1792 of yacc.c  */
#line 3089 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 788:
/* Line 1792 of yacc.c  */
#line 3093 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  }
    break;

  case 789:
/* Line 1792 of yacc.c  */
#line 3102 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
    break;

  case 790:
/* Line 1792 of yacc.c  */
#line 3110 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 791:
/* Line 1792 of yacc.c  */
#line 3117 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 792:
/* Line 1792 of yacc.c  */
#line 3118 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 793:
/* Line 1792 of yacc.c  */
#line 3122 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 794:
/* Line 1792 of yacc.c  */
#line 3127 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 795:
/* Line 1792 of yacc.c  */
#line 3133 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 796:
/* Line 1792 of yacc.c  */
#line 3136 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 797:
/* Line 1792 of yacc.c  */
#line 3141 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 798:
/* Line 1792 of yacc.c  */
#line 3142 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 799:
/* Line 1792 of yacc.c  */
#line 3143 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 800:
/* Line 1792 of yacc.c  */
#line 3144 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 801:
/* Line 1792 of yacc.c  */
#line 3145 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 802:
/* Line 1792 of yacc.c  */
#line 3149 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 868:
/* Line 1792 of yacc.c  */
#line 3157 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 869:
/* Line 1792 of yacc.c  */
#line 3157 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 872:
/* Line 1792 of yacc.c  */
#line 3157 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); }
    break;

  case 881:
/* Line 1792 of yacc.c  */
#line 3160 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 882:
/* Line 1792 of yacc.c  */
#line 3160 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 883:
/* Line 1792 of yacc.c  */
#line 3160 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 884:
/* Line 1792 of yacc.c  */
#line 3160 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 885:
/* Line 1792 of yacc.c  */
#line 3161 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 886:
/* Line 1792 of yacc.c  */
#line 3161 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 887:
/* Line 1792 of yacc.c  */
#line 3162 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 888:
/* Line 1792 of yacc.c  */
#line 3163 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 889:
/* Line 1792 of yacc.c  */
#line 3164 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 890:
/* Line 1792 of yacc.c  */
#line 3165 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 891:
/* Line 1792 of yacc.c  */
#line 3166 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 892:
/* Line 1792 of yacc.c  */
#line 3167 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 893:
/* Line 1792 of yacc.c  */
#line 3168 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 894:
/* Line 1792 of yacc.c  */
#line 3169 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 895:
/* Line 1792 of yacc.c  */
#line 3170 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 896:
/* Line 1792 of yacc.c  */
#line 3171 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 897:
/* Line 1792 of yacc.c  */
#line 3172 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 898:
/* Line 1792 of yacc.c  */
#line 3172 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 899:
/* Line 1792 of yacc.c  */
#line 3172 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 900:
/* Line 1792 of yacc.c  */
#line 3172 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 901:
/* Line 1792 of yacc.c  */
#line 3172 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 902:
/* Line 1792 of yacc.c  */
#line 3172 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 903:
/* Line 1792 of yacc.c  */
#line 3172 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;


/* Line 1792 of yacc.c  */
#line 9184 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 3174 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

